/**
 *
 * $Id: Expression.c,v 1.1.1.1 1996/08/06 05:51:12 toshok Exp $
 *
 * Copyright (C) 1995, 1996 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char *rcsid = "$Id: Expression.c,v 1.1.1.1 1996/08/06 05:51:12 toshok Exp $";

#include "UilMrm.h"

YYSTYPE
BooleanLiteral(Boolean v)
{
	uil_expression_t *r = (uil_expression_t *)XtMalloc(sizeof(uil_expression_t));

	r->type = s_expression;
	r->expression_type = e_literal;
	r->value_type = t_boolean;
	r->value = v;

	return r;
}

YYSTYPE
IntegerLiteral(char *s)
{
        uil_expression_t *r = (uil_expression_t *)XtMalloc(sizeof(uil_expression_t));

        XdbDebug(__FILE__, NULL, "IntegerLiteral %s\n", s);

        r->type = s_expression;
        r->expression_type = e_literal;
        r->value_type = t_integer;
        r->value = atoi(s);

        return r;
}

YYSTYPE
FloatLiteral(char *s)
{
        uil_expression_t *r = (uil_expression_t *)XtMalloc(sizeof(uil_expression_t));

        XdbDebug(__FILE__, NULL, "FloatLiteral %s\n", s);

        r->type = s_expression;
        r->expression_type = e_literal;
        r->value_type = t_float;
        r->value = atof(s);

        return r;
}

YYSTYPE
StringLiteral(char *s)
{
        uil_expression_t *r = (uil_expression_t *)XtMalloc(sizeof(uil_expression_t));

        XdbDebug(__FILE__, NULL, "StringLiteral %s\n", s);

        r->type = s_expression;
        r->expression_type = e_literal;
        r->value_type = t_float;
        r->value = XtNewString(s);

        return r;
}
