/**
 *
 * $Id: Features.c,v 1.1.1.1 1996/08/06 05:51:12 toshok Exp $
 *
 * Copyright (C) 1995, 1996 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char *rcsid = "$Id: Features.c,v 1.1.1.1 1996/08/06 05:51:12 toshok Exp $";

#include "UilMrm.h"

YYSTYPE
Features(YYSTYPE f, char *a)
{
	return f;
}

YYSTYPE
FeaturesControls(YYSTYPE features, YYSTYPE controls)
{
	uil_objects_t	*r,
			*f = (uil_objects_t *)features;

	if (features == NULL) {
		r = (uil_objects_t *)XtMalloc(sizeof(uil_objects_t));
		r->type = s_objects;
		r->arguments = r->callbacks = NULL;
	} else {
		r = features;
		r->callbacks = f->callbacks;
		r->arguments = f->arguments;
	}

/* FIX ME - should we concatenate here ? we could be overwriting things */

	r->controls = controls;

	return r;
}

YYSTYPE
FeaturesArguments(YYSTYPE features, YYSTYPE arguments)
{
	uil_objects_t	*r,
			*f = (uil_objects_t *)features;

	if (features == NULL) {
		r = (uil_objects_t *)XtMalloc(sizeof(uil_objects_t));
		r->type = s_objects;
		r->controls = r->callbacks = NULL;
	} else {
		r = features;
		r->controls = f->controls;
		r->callbacks = f->callbacks;
	}

/* FIX ME - should we concatenate here ? we could be overwriting things */

	r->arguments = arguments;

	return r;
}

YYSTYPE
FeaturesCallbacks(YYSTYPE features, YYSTYPE callbacks)
{
	uil_objects_t	*r,
			*f = (uil_objects_t *)features;

	if (features == NULL) {
		r = (uil_objects_t *)XtMalloc(sizeof(uil_objects_t));
		r->type = s_objects;
		r->arguments = r->controls = NULL;
	} else {
		r = features;
		r->controls = f->controls;
		r->arguments = f->arguments;
	}

/* FIX ME - should we concatenate here ? we could be overwriting things */

	r->callbacks = callbacks;

	return r;
}
