/**
 *
 * $Id: Identifier.c,v 1.2 1996/08/14 05:43:56 u27113 Exp $
 *
 * Copyright (C) 1995, 1996 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char *rcsid = "$Id: Identifier.c,v 1.2 1996/08/14 05:43:56 u27113 Exp $";

#include <stdio.h>

#include "UilMrm.h"
#include "Uil.h"
#include "Tree.h"
#include <XmI/DebugUtil.h>

YYSTYPE
Identifier(YYSTYPE name)
{
	uil_identifier_t	*id;

	id = (uil_identifier_t *)XtMalloc(sizeof(uil_identifier_t));
	id->type = s_identifier;
	id->name = XtNewString(name);
	id->left = id->right = NULL;

	TreeInsert((tree *)&UilGlobal->Identifiers, (tree)id);

	XdbDebug(__FILE__, NULL, "Identifier %s\n", name);

	return id;
}

void
IdentifierPrint(FILE *o, tree l)
{
	uil_identifier_t	*p = (uil_identifier_t *)l;

	fprintf(o, "<ID>%s\n",
		p->name);
}
