/**
 *
 * $Id: Module.c,v 1.1.1.1 1996/08/06 05:51:13 toshok Exp $
 *
 * Copyright (C) 1995, 1996 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

#include <stdio.h>
#include "UilMrm.h"
#include "Uil.h"
#include <X11/Intrinsic.h>

YYSTYPE
ModuleVersion(char *v)
{
	UilGlobal->uil_version = XtNewString(v);
	return NULL;
}

YYSTYPE
ModuleCaseSensitive(Boolean sens)
{
	UilGlobal->case_sensitive = sens;
	return NULL;
}

YYSTYPE
ModuleCharacterSet(char *charset)
{
	UilGlobal->character_set = XtNewString(charset);
	return NULL;
}

YYSTYPE
ModuleName(char *name)
{
	UilGlobal->module_name = XtNewString(name);
	return NULL;
}

void
ModulePrint(FILE *f)
{
	fprintf(f, "<MODULE>%s,%s,%c,%s\n",
		UilGlobal->module_name,
		UilGlobal->uil_version,
		UilGlobal->case_sensitive ? 's' : 'u',
		UilGlobal->character_set);
}
