/**
 *
 * $Id: Procedures.c,v 1.2 1996/08/14 05:43:59 u27113 Exp $
 *
 * Copyright (C) 1995 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char *rcsid = "$Id: Procedures.c,v 1.2 1996/08/14 05:43:59 u27113 Exp $";

#include <stdio.h>
#include <X11/Intrinsic.h>

#include "UilMrm.h"
#include "Uil.h"
#include "Tree.h"
#include <XmI/DebugUtil.h>

YYSTYPE
ProcedureListWithType(YYSTYPE name, YYSTYPE list)
{
	uil_procedures_t	*id;

	id = (uil_procedures_t *)XtMalloc(sizeof(uil_procedures_t));
	id->type = s_procedures;
	id->name = XtNewString(name);

	TreeInsert((tree *)&UilGlobal->Procedures, (tree)id);

	XdbDebug(__FILE__, NULL, "ProcedureListWithType(%s)\n", name);

	return id;
}

YYSTYPE
ProcedureListEmpty(YYSTYPE name)
{
	uil_procedures_t	*id;

	id = (uil_procedures_t *)XtMalloc(sizeof(uil_procedures_t));
	id->type = s_procedures;
	id->name = XtNewString(name);

	TreeInsert((tree *)&UilGlobal->Procedures, (tree)id);

	XdbDebug(__FILE__, NULL, "ProcedureListEmtpy(%s)\n", name);
	return id;
}

YYSTYPE
ProcedureList(YYSTYPE name)
{
	uil_procedures_t	*id;

	id = (uil_procedures_t *)XtMalloc(sizeof(uil_procedures_t));
	id->type = s_procedures;
	id->name = XtNewString(name);

	TreeInsert((tree *)&UilGlobal->Procedures, (tree)id);

	XdbDebug(__FILE__, NULL, "ProcedureList(%s)\n", name);
	return id;
}

void
ProcedurePrint(FILE *o, tree l)
{
	uil_procedures_t	*p = (uil_procedures_t *)l;

	fprintf(o, "<PR>%s\n",
		p->name);
}
