/**
 *
 * $Id: Arguments.c,v 1.1.1.1 1996/08/06 05:51:34 toshok Exp $
 *
 * Copyright (C) 1995, 1996 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char *rcsid = "$Id: Arguments.c,v 1.1.1.1 1996/08/06 05:51:34 toshok Exp $";

#include <stdio.h>
#include "UilMrm.h"
#include "Tree.h"

YYSTYPE
ArgumentsFromList(char *l)
{
	uil_arguments_t *r = (uil_arguments_t *)XtMalloc(sizeof(uil_arguments_t));

	r->type = s_arguments;
	r->name = NULL;			/* FIX ME */
	r->value = NULL;		/* FIX ME */

	r->left = r->right = NULL;

	return r;
}

YYSTYPE
ArgumentConcat(YYSTYPE list, YYSTYPE elem)
{
	tree	l = (tree) list,
		e = (tree) elem;

/* Only works if "elem" is a single element, not a list */
	e->left = NULL;
	e->right = l;

	return	e;
}

YYSTYPE
ArgumentIdIsExpression(char *name, YYSTYPE expression)
{
	uil_arguments_t *r = (uil_arguments_t *)XtMalloc(sizeof(uil_arguments_t));

	r->name = XtNewString(name);
	r->type = s_arguments;
	r->value = expression;		/* FIX ME */

	r->left = r->right = NULL;

	return r;
}

YYSTYPE
ArgumentIdIsIdId(char *name, char *id1, char *id2)
{
	uil_arguments_t *r = (uil_arguments_t *)XtMalloc(sizeof(uil_arguments_t));

	r->type = s_arguments;
	r->name = XtNewString(name);
	r->value = NULL;		/* FIX ME */

	r->left = r->right = NULL;

	return r;
}

void
ArgumentPrint(FILE *f, tree t)
{
	uil_arguments_t	*p = (uil_arguments_t *)t;

	fprintf(f, "<ARG>%s\n",
		p->name);
}
