/**
 *
 * $Id: Arrays.c,v 1.2 1996/08/14 05:45:10 u27113 Exp $
 *
 * Copyright (C) 1995 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char rcsid[] = "$Id: Arrays.c,v 1.2 1996/08/14 05:45:10 u27113 Exp $";

#include <Xm/XmAll.h>
#include <XmI/XmI.h>

#include "lookup.h"

CreateFunctionsType CreateFunctions[] = {
  {"XmArrowButton", XmCreateArrowButton },
  {"XmArrowButtonGadget", XmCreateArrowButtonGadget },
  {"XmBulletinBoard", XmCreateBulletinBoard },  
  {"XmBulletinBoardDialog", XmCreateBulletinBoardDialog },  
  {"XmCascadeButton", XmCreateCascadeButton },
  {"XmCascadeButtonGadget", XmCreateCascadeButtonGadget },
  {"XmCommand", XmCreateCommand },
  {"XmCommandDialog", XmCreateCommandDialog },
  {"XmDialogShell", XmCreateDialogShell },
  {"XmDragIcon", XmCreateDragIcon },
  {"XmDrawingArea", XmCreateDrawingArea },
  {"XmDrawnButton", XmCreateDrawnButton },
  {"XmErrorDialog", XmCreateErrorDialog },
  {"XmFileSelectionBox", XmCreateFileSelectionBox },
  {"XmFileSelectionDialog", XmCreateFileSelectionDialog },
  {"XmForm", XmCreateForm },  
  {"XmFormDialog", XmCreateFormDialog },  
  {"XmFrame", XmCreateFrame },
  {"XmInformationDialog", XmCreateInformationDialog },
  {"XmLabel", XmCreateLabel },
  {"XmLabelGadget", XmCreateLabelGadget },
  {"XmList", XmCreateList },
  {"XmMainWindow", XmCreateMainWindow },
  {"XmMenuBar", XmCreateMenuBar },
  {"XmMenuShell", XmCreateMenuShell },
  {"XmMessageBox", XmCreateMessageBox },
  {"XmMessageDialog", XmCreateMessageDialog },
  {"XmOptionMenu", XmCreateOptionMenu },
  {"XmPanedWindow", XmCreatePanedWindow },
  {"XmPopupMenu", XmCreatePopupMenu },
  {"XmPromptDialog", XmCreatePromptDialog },
  {"XmPulldownMenu", XmCreatePulldownMenu },
  {"XmPushButton", XmCreatePushButton },
  {"XmPushButtonGadget", XmCreatePushButtonGadget },
  {"XmQuestionDialog", XmCreateQuestionDialog },  
  {"XmRadioBox", XmCreateRadioBox },
  {"XmRowColumn", XmCreateRowColumn },
  {"XmScale", XmCreateScale },
  {"XmScrollBar", XmCreateScrollBar },
  {"XmScrolledList", XmCreateScrolledList },
  {"XmScrolledText", XmCreateScrolledText },
  {"XmScrolledWindow", XmCreateScrolledWindow },
  {"XmSelectionBox", XmCreateSelectionBox },
  {"XmSelectionDialog", XmCreateSelectionDialog },
  {"XmSeparator", XmCreateSeparator },
  {"XmSeparatorGadget", XmCreateSeparatorGadget },
  {"XmTemplateDialog", XmCreateTemplateDialog },
  {"XmText", XmCreateText },
  {"XmTextField", XmCreateTextField },
  {"XmToggleButton", XmCreateToggleButton },
  {"XmToggleButtonGadget", XmCreateToggleButtonGadget },
  {"XmWarningDialog", XmCreateWarningDialog },  
  {"XmWorkingDialog", XmCreateWorkingDialog },
  {"XmWorkArea", XmCreateWorkArea },
};

ArgNamesType ArgNames[] = {
  { "XmNaccelerator", XmNaccelerator},
  { "XmNacceleratorText", XmNacceleratorText},
  { "XmNaccelerators", XmNaccelerators},
  { "XmNactivateCallback", XmNactivateCallback},
  { "XmNadjustLast", XmNadjustLast},
  { "XmNadjustMargin", XmNadjustMargin},
  { "XmNalignment", XmNalignment},
  { "XmNallowOverlap", XmNallowOverlap},
  { "XmNallowResize", XmNallowResize},
  { "XmNallowShellResize", XmNallowShellResize},
  { "XmNancestorSensitive", XmNancestorSensitive},
  { "XmNanimationMask", XmNanimationMask},
  { "XmNanimationPixmap", XmNanimationPixmap},
  { "XmNanimationPixmapDepth", XmNanimationPixmapDepth},
  { "XmNanimationStyle", XmNanimationStyle},
  { "XmNapplyCallback", XmNapplyCallback},
  { "XmNapplyLabelString", XmNapplyLabelString},
  { "XmNargc", XmNargc},
  { "XmNargv", XmNargv},
  { "XmNarmCallback", XmNarmCallback},
  { "XmNarmColor", XmNarmColor},
  { "XmNarmPixmap", XmNarmPixmap},
  { "XmNarrowDirection", XmNarrowDirection},
  { "XmNattachment", XmNattachment},
  { "XmNaudibleWarning", XmNaudibleWarning},
  { "XmNautoShowCursorPosition", XmNautoShowCursorPosition},
  { "XmNautoUnmanage", XmNautoUnmanage},
  { "XmNautomaticSelection", XmNautomaticSelection},
  { "XmNavailability", XmNavailability},
  { "XmNbackground", XmNbackground},
  { "XmNbackgroundPixmap", XmNbackgroundPixmap},
  { "XmNbaseHeight", XmNbaseHeight},
  { "XmNbaseWidth", XmNbaseWidth},
  { "XmNbitmap", XmNbitmap},
  { "XmNblendModel", XmNblendModel},
  { "XmNblinkRate", XmNblinkRate},
  { "XmNborder", XmNborder},
  { "XmNborderColor", XmNborderColor},
  { "XmNborderPixmap", XmNborderPixmap},
  { "XmNborderWidth", XmNborderWidth},
  { "XmNbottomAttachment", XmNbottomAttachment},
  { "XmNbottomOffset", XmNbottomOffset},
  { "XmNbottomPosition", XmNbottomPosition},
  { "XmNbottomShadowColor", XmNbottomShadowColor},
  { "XmNbottomShadowPixmap", XmNbottomShadowPixmap},
  { "XmNbottomWidget", XmNbottomWidget},
  { "XmNbrowseSelectionCallback", XmNbrowseSelectionCallback},
  { "XmNbuttonAcceleratorText", XmNbuttonAcceleratorText},
  { "XmNbuttonAccelerators", XmNbuttonAccelerators},
  { "XmNbuttonCount", XmNbuttonCount},
  { "XmNbuttonFontList", XmNbuttonFontList},
  { "XmNbuttonMnemonicCharSets", XmNbuttonMnemonicCharSets},
  { "XmNbuttonMnemonics", XmNbuttonMnemonics},
  { "XmNbuttonSet", XmNbuttonSet},
  { "XmNbuttonType", XmNbuttonType},
  { "XmNbuttons", XmNbuttons},
  { "XmNcallback", XmNcallback},
  { "XmNcancelButton", XmNcancelButton},
  { "XmNcancelCallback", XmNcancelCallback},
  { "XmNcancelLabelString", XmNcancelLabelString},
  { "XmNcascadePixmap", XmNcascadePixmap},
  { "XmNcascadingCallback", XmNcascadingCallback},
  { "XmNchildHorizontalAlignment", XmNchildHorizontalAlignment},
  { "XmNchildHorizontalSpacing", XmNchildHorizontalSpacing},
  { "XmNchildPlacement", XmNchildPlacement},
  { "XmNchildPosition", XmNchildPosition},
  { "XmNchildType", XmNchildType},
  { "XmNchildVerticalAlignment", XmNchildVerticalAlignment},
  { "XmNchildren", XmNchildren},
  { "XmNclientData", XmNclientData},
  { "XmNclipWindow", XmNclipWindow},
  { "XmNcolormap", XmNcolormap},
  { "XmNcolumns", XmNcolumns},
  { "XmNcommand", XmNcommand},
  { "XmNcommandChangedCallback", XmNcommandChangedCallback},
  { "XmNcommandEnteredCallback", XmNcommandEnteredCallback},
  { "XmNcommandWindow", XmNcommandWindow},
  { "XmNcommandWindowLocation", XmNcommandWindowLocation},
  { "XmNconvertProc", XmNconvertProc},
  { "XmNcreatePopupChildProc", XmNcreatePopupChildProc},
  { "XmNcursorBackground", XmNcursorBackground},
  { "XmNcursorForeground", XmNcursorForeground},
  { "XmNcursorPosition", XmNcursorPosition},
  { "XmNcursorPositionVisible", XmNcursorPositionVisible},
  { "XmNdarkThreshold", XmNdarkThreshold},
  { "XmNdecimalPoints", XmNdecimalPoints},
  { "XmNdecrementCallback", XmNdecrementCallback},
  { "XmNdefaultActionCallback", XmNdefaultActionCallback},
  { "XmNdefaultButton", XmNdefaultButton},
  { "XmNdefaultButtonShadowThickness", XmNdefaultButtonShadowThickness},
  { "XmNdefaultButtonType", XmNdefaultButtonType},
  { "XmNdefaultCopyCursorIcon", XmNdefaultCopyCursorIcon},
  { "XmNdefaultFontList", XmNdefaultFontList},
  { "XmNdefaultInvalidCursorIcon", XmNdefaultInvalidCursorIcon},
  { "XmNdefaultLinkCursorIcon", XmNdefaultLinkCursorIcon},
  { "XmNdefaultMoveCursorIcon", XmNdefaultMoveCursorIcon},
  { "XmNdefaultNoneCursorIcon", XmNdefaultNoneCursorIcon},
  { "XmNdefaultPosition", XmNdefaultPosition},
  { "XmNdefaultSourceCursorIcon", XmNdefaultSourceCursorIcon},
  { "XmNdefaultValidCursorIcon", XmNdefaultValidCursorIcon},
  { "XmNdefaultVirtualBindings", XmNdefaultVirtualBindings},
  { "XmNdeleteResponse", XmNdeleteResponse},
  { "XmNdepth", XmNdepth},
  { "XmNdesktopParent", XmNdesktopParent},
  { "XmNdestroyCallback", XmNdestroyCallback},
  { "XmNdialogStyle", XmNdialogStyle},
  { "XmNdialogTitle", XmNdialogTitle},
  { "XmNdialogType", XmNdialogType},
  { "XmNdirListItemCount", XmNdirListItemCount},
  { "XmNdirListItems", XmNdirListItems},
  { "XmNdirListLabelString", XmNdirListLabelString},
  { "XmNdirMask", XmNdirMask},
  { "XmNdirSearchProc", XmNdirSearchProc},
  { "XmNdirSpec", XmNdirSpec},
  { "XmNdirectory", XmNdirectory},
  { "XmNdirectoryValid", XmNdirectoryValid},
  { "XmNdisarmCallback", XmNdisarmCallback},
  { "XmNdoubleClickInterval", XmNdoubleClickInterval},
  { "XmNdragCallback", XmNdragCallback},
  { "XmNdragContextClass", XmNdragContextClass},
  { "XmNdragDropFinishCallback", XmNdragDropFinishCallback},
  { "XmNdragIconClass", XmNdragIconClass},
  { "XmNdragInitiatorProtocolStyle", XmNdragInitiatorProtocolStyle},
  { "XmNdragMotionCallback", XmNdragMotionCallback},
  { "XmNdragOperations", XmNdragOperations},
  { "XmNdragOverMode", XmNdragOverMode},
  { "XmNdragProc", XmNdragProc},
  { "XmNdragReceiverProtocolStyle", XmNdragReceiverProtocolStyle},
  { "XmNdropFinishCallback", XmNdropFinishCallback},
  { "XmNdropProc", XmNdropProc},
  { "XmNdropRectangles", XmNdropRectangles},
  { "XmNdropSiteActivity", XmNdropSiteActivity},
  { "XmNdropSiteEnterCallback", XmNdropSiteEnterCallback},
  { "XmNdropSiteLeaveCallback", XmNdropSiteLeaveCallback},
  { "XmNdropSiteManagerClass", XmNdropSiteManagerClass},
  { "XmNdropSiteOperations", XmNdropSiteOperations},
  { "XmNdropSiteType", XmNdropSiteType},
  { "XmNdropStartCallback", XmNdropStartCallback},
  { "XmNdropTransferClass", XmNdropTransferClass},
  { "XmNdropTransfers", XmNdropTransfers},
  { "XmNeditMode", XmNeditMode},
  { "XmNeditType", XmNeditType},
  { "XmNeditable", XmNeditable},
  { "XmNentryAlignment", XmNentryAlignment},
  { "XmNentryBorder", XmNentryBorder},
  { "XmNentryCallback", XmNentryCallback},
  { "XmNentryClass", XmNentryClass},
  { "XmNentryVerticalAlignment", XmNentryVerticalAlignment},
  { "XmNexportTargets", XmNexportTargets},
  { "XmNexposeCallback", XmNexposeCallback},
  { "XmNextendedSelectionCallback", XmNextendedSelectionCallback},
  { "XmNextensionType", XmNextensionType},
  { "XmNfile", XmNfile},
  { "XmNfileListItemCount", XmNfileListItemCount},
  { "XmNfileListItems", XmNfileListItems},
  { "XmNfileListLabelString", XmNfileListLabelString},
  { "XmNfileSearchProc", XmNfileSearchProc},
  { "XmNfileTypeMask", XmNfileTypeMask},
  { "XmNfillOnArm", XmNfillOnArm},
  { "XmNfillOnSelect", XmNfillOnSelect},
  { "XmNfilterLabelString", XmNfilterLabelString},
  { "XmNfocusCallback", XmNfocusCallback},
  { "XmNfocusMovedCallback", XmNfocusMovedCallback},
  { "XmNfocusPolicyChanged", XmNfocusPolicyChanged},
  { "XmNfont", XmNfont},
  { "XmNfontList", XmNfontList},
  { "XmNfontSet", XmNfontSet},
  { "XmNforceBars", XmNforceBars},
  { "XmNforeground", XmNforeground},
  { "XmNforegroundThreshold", XmNforegroundThreshold},
  { "XmNfractionBase", XmNfractionBase},
  { "XmNfunction", XmNfunction},
  { "XmNgainPrimaryCallback", XmNgainPrimaryCallback},
  { "XmNgeometry", XmNgeometry},
  { "XmNheight", XmNheight},
  { "XmNheightInc", XmNheightInc},
  { "XmNhelpCallback", XmNhelpCallback},
  { "XmNhelpLabelString", XmNhelpLabelString},
  { "XmNhighlight", XmNhighlight},
  { "XmNhighlightColor", XmNhighlightColor},
  { "XmNhighlightOnEnter", XmNhighlightOnEnter},
  { "XmNhighlightPixmap", XmNhighlightPixmap},
  { "XmNhighlightThickness", XmNhighlightThickness},
  { "XmNhistoryItemCount", XmNhistoryItemCount},
  { "XmNhistoryItems", XmNhistoryItems},
  { "XmNhistoryMaxItems", XmNhistoryMaxItems},
  { "XmNhistoryVisibleItemCount", XmNhistoryVisibleItemCount},
  { "XmNhorizontalFontUnit", XmNhorizontalFontUnit},
  { "XmNhorizontalScrollBar", XmNhorizontalScrollBar},
  { "XmNhorizontalSpacing", XmNhorizontalSpacing},
  { "XmNhotX", XmNhotX},
  { "XmNhotY", XmNhotY},
  { "XmNiccHandle", XmNiccHandle},
  { "XmNiconMask", XmNiconMask},
  { "XmNiconName", XmNiconName},
  { "XmNiconNameEncoding", XmNiconNameEncoding},
  { "XmNiconPixmap", XmNiconPixmap},
  { "XmNiconWindow", XmNiconWindow},
  { "XmNiconX", XmNiconX},
  { "XmNiconY", XmNiconY},
  { "XmNiconic", XmNiconic},
  { "XmNimportTargets", XmNimportTargets},
  { "XmNincrement", XmNincrement},
  { "XmNincrementCallback", XmNincrementCallback},
  { "XmNincremental", XmNincremental},
  { "XmNindex", XmNindex},
  { "XmNindicatorOn", XmNindicatorOn},
  { "XmNindicatorSize", XmNindicatorSize},
  { "XmNindicatorType", XmNindicatorType},
  { "XmNinitialDelay", XmNinitialDelay},
  { "XmNinitialFocus", XmNinitialFocus},
  { "XmNinitialResourcesPersistent", XmNinitialResourcesPersistent},
  { "XmNinitialState", XmNinitialState},
  { "XmNinnerHeight", XmNinnerHeight},
  { "XmNinnerWidth", XmNinnerWidth},
  { "XmNinnerWindow", XmNinnerWindow},
  { "XmNinput", XmNinput},
  { "XmNinputCallback", XmNinputCallback},
  { "XmNinputCreate", XmNinputCreate},
  { "XmNinputMethod", XmNinputMethod},
  { "XmNinsertPosition", XmNinsertPosition},
  { "XmNinternalHeight", XmNinternalHeight},
  { "XmNinternalWidth", XmNinternalWidth},
  { "XmNinvalidCursorForeground", XmNinvalidCursorForeground},
  { "XmNisAligned", XmNisAligned},
  { "XmNisHomogeneous", XmNisHomogeneous},
  { "XmNitemCount", XmNitemCount},
  { "XmNitems", XmNitems},
  { "XmNjumpProc", XmNjumpProc},
  { "XmNjustify", XmNjustify},
  { "XmNkeyboardFocusPolicy", XmNkeyboardFocusPolicy},
  { "XmNlabelFontList", XmNlabelFontList},
  { "XmNlabelInsensitivePixmap", XmNlabelInsensitivePixmap},
  { "XmNlabelPixmap", XmNlabelPixmap},
  { "XmNlabelString", XmNlabelString},
  { "XmNlabelType", XmNlabelType},
  { "XmNleftAttachment", XmNleftAttachment},
  { "XmNleftOffset", XmNleftOffset},
  { "XmNleftPosition", XmNleftPosition},
  { "XmNleftWidget", XmNleftWidget},
  { "XmNlength", XmNlength},
  { "XmNlightThreshold", XmNlightThreshold},
  { "XmNlineSpace", XmNlineSpace},
  { "XmNlistItemCount", XmNlistItemCount},
  { "XmNlistItems", XmNlistItems},
  { "XmNlistLabelString", XmNlistLabelString},
  { "XmNlistMarginHeight", XmNlistMarginHeight},
  { "XmNlistMarginWidth", XmNlistMarginWidth},
  { "XmNlistSizePolicy", XmNlistSizePolicy},
  { "XmNlistSpacing", XmNlistSpacing},
  { "XmNlistUpdated", XmNlistUpdated},
  { "XmNlistVisibleItemCount", XmNlistVisibleItemCount},
  { "XmNlogicalParent", XmNlogicalParent},
  { "XmNlosePrimaryCallback", XmNlosePrimaryCallback},
  { "XmNlosingFocusCallback", XmNlosingFocusCallback},
  { "XmNlowerRight", XmNlowerRight},
  { "XmNmainWindowMarginHeight", XmNmainWindowMarginHeight},
  { "XmNmainWindowMarginWidth", XmNmainWindowMarginWidth},
  { "XmNmapCallback", XmNmapCallback},
  { "XmNmappedWhenManaged", XmNmappedWhenManaged},
  { "XmNmappingDelay", XmNmappingDelay},
  { "XmNmargin", XmNmargin},
  { "XmNmarginBottom", XmNmarginBottom},
  { "XmNmarginHeight", XmNmarginHeight},
  { "XmNmarginLeft", XmNmarginLeft},
  { "XmNmarginRight", XmNmarginRight},
  { "XmNmarginTop", XmNmarginTop},
  { "XmNmarginWidth", XmNmarginWidth},
  { "XmNmask", XmNmask},
  { "XmNmaxAspectX", XmNmaxAspectX},
  { "XmNmaxAspectY", XmNmaxAspectY},
  { "XmNmaxHeight", XmNmaxHeight},
  { "XmNmaxLength", XmNmaxLength},
  { "XmNmaxWidth", XmNmaxWidth},
  { "XmNmaximum", XmNmaximum},
  { "XmNmenuAccelerator", XmNmenuAccelerator},
  { "XmNmenuBar", XmNmenuBar},
  { "XmNmenuCursor", XmNmenuCursor},
  { "XmNmenuEntry", XmNmenuEntry},
  { "XmNmenuHelpWidget", XmNmenuHelpWidget},
  { "XmNmenuHistory", XmNmenuHistory},
  { "XmNmenuPost", XmNmenuPost},
  { "XmNmessageAlignment", XmNmessageAlignment},
  { "XmNmessageProc", XmNmessageProc},
  { "XmNmessageString", XmNmessageString},
  { "XmNmessageWindow", XmNmessageWindow},
  { "XmNminAspectX", XmNminAspectX},
  { "XmNminAspectY", XmNminAspectY},
  { "XmNminHeight", XmNminHeight},
  { "XmNminWidth", XmNminWidth},
  { "XmNminimizeButtons", XmNminimizeButtons},
  { "XmNminimum", XmNminimum},
  { "XmNmnemonic", XmNmnemonic},
  { "XmNmnemonicCharSet", XmNmnemonicCharSet},
  { "XmNmodifyVerifyCallback", XmNmodifyVerifyCallback},
  { "XmNmodifyVerifyCallbackWcs", XmNmodifyVerifyCallbackWcs},
  { "XmNmotionVerifyCallback", XmNmotionVerifyCallback},
  { "XmNmoveOpaque", XmNmoveOpaque},
  { "XmNmultiClick", XmNmultiClick},
  { "XmNmultipleSelectionCallback", XmNmultipleSelectionCallback},
  { "XmNmustMatch", XmNmustMatch},
  { "XmNmwmDecorations", XmNmwmDecorations},
  { "XmNmwmFunctions", XmNmwmFunctions},
  { "XmNmwmInputMode", XmNmwmInputMode},
  { "XmNmwmMenu", XmNmwmMenu},
  { "XmNmwmMessages", XmNmwmMessages},
  { "XmNname", XmNname},
  { "XmNnavigationType", XmNnavigationType},
  { "XmNneedsMotion", XmNneedsMotion},
  { "XmNnoMatchCallback", XmNnoMatchCallback},
  { "XmNnoMatchString", XmNnoMatchString},
  { "XmNnoResize", XmNnoResize},
  { "XmNnoneCursorForeground", XmNnoneCursorForeground},
  { "XmNnotify", XmNnotify},
  { "XmNnotifyProc", XmNnotifyProc},
  { "XmNnumChildren", XmNnumChildren},
  { "XmNnumColumns", XmNnumColumns},
  { "XmNnumDropRectangles", XmNnumDropRectangles},
  { "XmNnumDropTransfers", XmNnumDropTransfers},
  { "XmNnumExportTargets", XmNnumExportTargets},
  { "XmNnumImportTargets", XmNnumImportTargets},
  { "XmNnumRectangles", XmNnumRectangles},
  { "XmNoffsetX", XmNoffsetX},
  { "XmNoffsetY", XmNoffsetY},
  { "XmNokCallback", XmNokCallback},
  { "XmNokLabelString", XmNokLabelString},
  { "XmNoperatingCursorIcon", XmNoperatingCursorIcon},
  { "XmNoperationChangedCallback", XmNoperationChangedCallback},
  { "XmNoperationCursorIcon", XmNoperationCursorIcon},
  { "XmNoptionLabel", XmNoptionLabel},
  { "XmNoptionMnemonic", XmNoptionMnemonic},
  { "XmNorientation", XmNorientation},
  { "XmNoutputCreate", XmNoutputCreate},
  { "XmNoverrideRedirect", XmNoverrideRedirect},
  { "XmNpacking", XmNpacking},
  { "XmNpageDecrementCallback", XmNpageDecrementCallback},
  { "XmNpageIncrement", XmNpageIncrement},
  { "XmNpageIncrementCallback", XmNpageIncrementCallback},
  { "XmNpaneMaximum", XmNpaneMaximum},
  { "XmNpaneMinimum", XmNpaneMinimum},
  { "XmNparameter", XmNparameter},
  { "XmNpattern", XmNpattern},
  { "XmNpendingDelete", XmNpendingDelete},
  { "XmNpixmap", XmNpixmap},
  { "XmNpopdownCallback", XmNpopdownCallback},
  { "XmNpopupCallback", XmNpopupCallback},
  { "XmNpopupEnabled", XmNpopupEnabled},
  { "XmNpositionIndex", XmNpositionIndex},
  { "XmNpostFromButton", XmNpostFromButton},
  { "XmNpostFromCount", XmNpostFromCount},
  { "XmNpostFromList", XmNpostFromList},
  { "XmNpreeditType", XmNpreeditType},
  { "XmNprocessingDirection", XmNprocessingDirection},
  { "XmNpromptString", XmNpromptString},
  { "XmNprotocolCallback", XmNprotocolCallback},
  { "XmNpushButtonEnabled", XmNpushButtonEnabled},
  { "XmNqualifySearchDataProc", XmNqualifySearchDataProc},
  { "XmNradioAlwaysOne", XmNradioAlwaysOne},
  { "XmNradioBehavior", XmNradioBehavior},
  { "XmNrealizeCallback", XmNrealizeCallback},
  { "XmNrecomputeSize", XmNrecomputeSize},
  { "XmNrectangles", XmNrectangles},
  { "XmNrefigureMode", XmNrefigureMode},
  { "XmNrepeatDelay", XmNrepeatDelay},
  { "XmNresizable", XmNresizable},
  { "XmNresize", XmNresize},
  { "XmNresizeCallback", XmNresizeCallback},
  { "XmNresizeHeight", XmNresizeHeight},
  { "XmNresizePolicy", XmNresizePolicy},
  { "XmNresizeWidth", XmNresizeWidth},
  { "XmNreverseVideo", XmNreverseVideo},
  { "XmNrightAttachment", XmNrightAttachment},
  { "XmNrightOffset", XmNrightOffset},
  { "XmNrightPosition", XmNrightPosition},
  { "XmNrightWidget", XmNrightWidget},
  { "XmNrowColumnType", XmNrowColumnType},
  { "XmNrows", XmNrows},
  { "XmNrubberPositioning", XmNrubberPositioning},
  { "XmNsashHeight", XmNsashHeight},
  { "XmNsashIndent", XmNsashIndent},
  { "XmNsashShadowThickness", XmNsashShadowThickness},
  { "XmNsashWidth", XmNsashWidth},
  { "XmNsaveUnder", XmNsaveUnder},
  { "XmNscaleHeight", XmNscaleHeight},
  { "XmNscaleMultiple", XmNscaleMultiple},
  { "XmNscaleWidth", XmNscaleWidth},
  { "XmNscreen", XmNscreen},
  { "XmNscrollBarDisplayPolicy", XmNscrollBarDisplayPolicy},
  { "XmNscrollBarPlacement", XmNscrollBarPlacement},
  { "XmNscrollDCursor", XmNscrollDCursor},
  { "XmNscrollHCursor", XmNscrollHCursor},
  { "XmNscrollHorizontal", XmNscrollHorizontal},
  { "XmNscrollLCursor", XmNscrollLCursor},
  { "XmNscrollLeftSide", XmNscrollLeftSide},
  { "XmNscrollProc", XmNscrollProc},
  { "XmNscrollRCursor", XmNscrollRCursor},
  { "XmNscrollTopSide", XmNscrollTopSide},
  { "XmNscrollUCursor", XmNscrollUCursor},
  { "XmNscrollVCursor", XmNscrollVCursor},
  { "XmNscrollVertical", XmNscrollVertical},
  { "XmNscrolledWindowMarginHeight", XmNscrolledWindowMarginHeight},
  { "XmNscrolledWindowMarginWidth", XmNscrolledWindowMarginWidth},
  { "XmNscrollingPolicy", XmNscrollingPolicy},
  { "XmNselectColor", XmNselectColor},
  { "XmNselectInsensitivePixmap", XmNselectInsensitivePixmap},
  { "XmNselectPixmap", XmNselectPixmap},
  { "XmNselectThreshold", XmNselectThreshold},
  { "XmNselectedItemCount", XmNselectedItemCount},
  { "XmNselectedItems", XmNselectedItems},
  { "XmNselection", XmNselection},
  { "XmNselectionArray", XmNselectionArray},
  { "XmNselectionArrayCount", XmNselectionArrayCount},
  { "XmNselectionLabelString", XmNselectionLabelString},
  { "XmNselectionPolicy", XmNselectionPolicy},
  { "XmNsensitive", XmNsensitive},
  { "XmNseparatorOn", XmNseparatorOn},
  { "XmNseparatorType", XmNseparatorType},
  { "XmNset", XmNset},
  { "XmNshadow", XmNshadow},
  { "XmNshadowThickness", XmNshadowThickness},
  { "XmNshadowType", XmNshadowType},
  { "XmNshellUnitType", XmNshellUnitType},
  { "XmNshowArrows", XmNshowArrows},
  { "XmNshowAsDefault", XmNshowAsDefault},
  { "XmNshowSeparator", XmNshowSeparator},
  { "XmNshowValue", XmNshowValue},
  { "XmNshown", XmNshown},
  { "XmNsimpleCallback", XmNsimpleCallback},
  { "XmNsingleSelectionCallback", XmNsingleSelectionCallback},
  { "XmNsizePolicy", XmNsizePolicy},
  { "XmNskipAdjust", XmNskipAdjust},
  { "XmNsliderSize", XmNsliderSize},
  { "XmNsource", XmNsource},
  { "XmNsourceCursorIcon", XmNsourceCursorIcon},
  { "XmNsourceIsExternal", XmNsourceIsExternal},
  { "XmNsourcePixmapIcon", XmNsourcePixmapIcon},
  { "XmNsourceWidget", XmNsourceWidget},
  { "XmNsourceWindow", XmNsourceWindow},
  { "XmNspace", XmNspace},
  { "XmNspacing", XmNspacing},
  { "XmNspotLocation", XmNspotLocation},
  { "XmNstartTime", XmNstartTime},
  { "XmNstateCursorIcon", XmNstateCursorIcon},
  { "XmNstring", XmNstring},
  { "XmNstringDirection", XmNstringDirection},
  { "XmNsubMenuId", XmNsubMenuId},
  { "XmNsymbolPixmap", XmNsymbolPixmap},
  { "XmNtearOffMenuActivateCallback", XmNtearOffMenuActivateCallback},
  { "XmNtearOffMenuDeactivateCallback", XmNtearOffMenuDeactivateCallback},
  { "XmNtearOffModel", XmNtearOffModel},
  { "XmNtextAccelerators", XmNtextAccelerators},
  { "XmNtextColumns", XmNtextColumns},
  { "XmNtextFontList", XmNtextFontList},
  { "XmNtextOptions", XmNtextOptions},
  { "XmNtextSink", XmNtextSink},
  { "XmNtextSource", XmNtextSource},
  { "XmNtextString", XmNtextString},
  { "XmNtextTranslations", XmNtextTranslations},
  { "XmNtextValue", XmNtextValue},
  { "XmNthickness", XmNthickness},
  { "XmNthumb", XmNthumb},
  { "XmNthumbProc", XmNthumbProc},
  { "XmNtitle", XmNtitle},
  { "XmNtitleEncoding", XmNtitleEncoding},
  { "XmNtitleString", XmNtitleString},
  { "XmNtoBottomCallback", XmNtoBottomCallback},
  { "XmNtoPositionCallback", XmNtoPositionCallback},
  { "XmNtoTopCallback", XmNtoTopCallback},
  { "XmNtop", XmNtop},
  { "XmNtopAttachment", XmNtopAttachment},
  { "XmNtopCharacter", XmNtopCharacter},
  { "XmNtopItemPosition", XmNtopItemPosition},
  { "XmNtopLevelEnterCallback", XmNtopLevelEnterCallback},
  { "XmNtopLevelLeaveCallback", XmNtopLevelLeaveCallback},
  { "XmNtopOffset", XmNtopOffset},
  { "XmNtopPosition", XmNtopPosition},
  { "XmNtopShadowColor", XmNtopShadowColor},
  { "XmNtopShadowPixmap", XmNtopShadowPixmap},
  { "XmNtopWidget", XmNtopWidget},
  { "XmNtransferProc", XmNtransferProc},
  { "XmNtransferStatus", XmNtransferStatus},
  { "XmNtransient", XmNtransient},
  { "XmNtransientFor", XmNtransientFor},
  { "XmNtranslations", XmNtranslations},
  { "XmNtraversalCallback", XmNtraversalCallback},
  { "XmNtraversalOn", XmNtraversalOn},
  { "XmNtraversalType", XmNtraversalType},
  { "XmNtraverseObscuredCallback", XmNtraverseObscuredCallback},
  { "XmNtreeUpdateProc", XmNtreeUpdateProc},
  { "XmNtroughColor", XmNtroughColor},
  { "XmNunitType", XmNunitType},
  { "XmNunmapCallback", XmNunmapCallback},
  { "XmNunpostBehavior", XmNunpostBehavior},
  { "XmNunselectPixmap", XmNunselectPixmap},
  { "XmNupdate", XmNupdate},
  { "XmNupdateSliderSize", XmNupdateSliderSize},
  { "XmNuseAsyncGeometry", XmNuseAsyncGeometry},
  { "XmNuseBottom", XmNuseBottom},
  { "XmNuseRight", XmNuseRight},
  { "XmNuserData", XmNuserData},
  { "XmNvalidCursorForeground", XmNvalidCursorForeground},
  { "XmNvalue", XmNvalue},
  { "XmNvalueChangedCallback", XmNvalueChangedCallback},
  { "XmNvalueWcs", XmNvalueWcs},
  { "XmNverifyBell", XmNverifyBell},
  { "XmNverticalFontUnit", XmNverticalFontUnit},
  { "XmNverticalScrollBar", XmNverticalScrollBar},
  { "XmNverticalSpacing", XmNverticalSpacing},
  { "XmNvisibleItemCount", XmNvisibleItemCount},
  { "XmNvisibleWhenOff", XmNvisibleWhenOff},
  { "XmNvisual", XmNvisual},
  { "XmNvisualPolicy", XmNvisualPolicy},
  { "XmNwaitForWm", XmNwaitForWm},
  { "XmNwhichButton", XmNwhichButton},
  { "XmNwidth", XmNwidth},
  { "XmNwidthInc", XmNwidthInc},
  { "XmNwinGravity", XmNwinGravity},
  { "XmNwindow", XmNwindow},
  { "XmNwindowGroup", XmNwindowGroup},
  { "XmNwmTimeout", XmNwmTimeout},
  { "XmNwordWrap", XmNwordWrap},
  { "XmNworkWindow", XmNworkWindow},
  { "XmNx", XmNx},
  { "XmNy", XmNy},
};


PredefinedType Predefines[] = {
  { "FMT16BIT", (XtPointer) FMT16BIT },
  { "FMT8BIT", (XtPointer) FMT8BIT },
  { "Xm1000TH_INCHES", (XtPointer) Xm1000TH_INCHES },
  { "Xm100TH_FONT_UNITS", (XtPointer) Xm100TH_FONT_UNITS },
  { "Xm100TH_MILLIMETERS", (XtPointer) Xm100TH_MILLIMETERS },
  { "Xm100TH_POINTS", (XtPointer) Xm100TH_POINTS },
  { "XmALIGNMENT_BASELINE_BOTTOM", (XtPointer) XmALIGNMENT_BASELINE_BOTTOM },
  { "XmALIGNMENT_BASELINE_TOP", (XtPointer) XmALIGNMENT_BASELINE_TOP },
  { "XmALIGNMENT_BEGINNING", (XtPointer) XmALIGNMENT_BEGINNING },
  { "XmALIGNMENT_CENTER", (XtPointer) XmALIGNMENT_CENTER },
  { "XmALIGNMENT_CONTENTS_BOTTOM", (XtPointer) XmALIGNMENT_CONTENTS_BOTTOM },
  { "XmALIGNMENT_CONTENTS_TOP", (XtPointer) XmALIGNMENT_CONTENTS_TOP },
  { "XmALIGNMENT_END", (XtPointer) XmALIGNMENT_END },
  { "XmALIGNMENT_WIDGET_BOTTOM", (XtPointer) XmALIGNMENT_WIDGET_BOTTOM },
  { "XmALIGNMENT_WIDGET_TOP", (XtPointer) XmALIGNMENT_WIDGET_TOP },
  { "XmAPPLICATION_DEFINED", (XtPointer) XmAPPLICATION_DEFINED },
  { "XmARROW_DOWN", (XtPointer) XmARROW_DOWN },
  { "XmARROW_LEFT", (XtPointer) XmARROW_LEFT },
  { "XmARROW_RIGHT", (XtPointer) XmARROW_RIGHT },
  { "XmARROW_UP", (XtPointer) XmARROW_UP },
  { "XmAS_NEEDED", (XtPointer) XmAS_NEEDED },
  { "XmATTACH_FORM", (XtPointer) XmATTACH_FORM },
  { "XmATTACH_NONE", (XtPointer) XmATTACH_NONE },
  { "XmATTACH_OPPOSITE_FORM", (XtPointer) XmATTACH_OPPOSITE_FORM },
  { "XmATTACH_OPPOSITE_WIDGET", (XtPointer) XmATTACH_OPPOSITE_WIDGET },
  { "XmATTACH_POSITION", (XtPointer) XmATTACH_POSITION },
  { "XmATTACH_SELF", (XtPointer) XmATTACH_SELF },
  { "XmATTACH_WIDGET", (XtPointer) XmATTACH_WIDGET },
  { "XmAUTOMATIC", (XtPointer) XmAUTOMATIC },
  { "XmBELL", (XtPointer) XmBELL },
  { "XmBOTTOM_LEFT", (XtPointer) XmBOTTOM_LEFT },
  { "XmBOTTOM_RIGHT", (XtPointer) XmBOTTOM_RIGHT },
  { "XmBROWSE_SELECT", (XtPointer) XmBROWSE_SELECT },
  { "XmCASCADEBUTTON", (XtPointer) XmCASCADEBUTTON },
  { "XmCHECKBUTTON", (XtPointer) XmCHECKBUTTON },
  { "XmCOMMAND_ABOVE_WORKSPACE", (XtPointer) XmCOMMAND_ABOVE_WORKSPACE },
  { "XmCOMMAND_BELOW_WORKSPACE", (XtPointer) XmCOMMAND_BELOW_WORKSPACE },
  { "XmCONSTANT", (XtPointer) XmCONSTANT },
  { "XmCOPY_FAILED", (XtPointer) XmCOPY_FAILED },
  { "XmCOPY_SUCCEEDED", (XtPointer) XmCOPY_SUCCEEDED },
  { "XmCOPY_TRUNCATED", (XtPointer) XmCOPY_TRUNCATED },
  { "XmCR_ACTIVATE", (XtPointer) XmCR_ACTIVATE },
  { "XmCR_APPLY", (XtPointer) XmCR_APPLY },
  { "XmCR_ARM", (XtPointer) XmCR_ARM },
  { "XmCR_BROWSE_SELECT", (XtPointer) XmCR_BROWSE_SELECT },
  { "XmCR_CANCEL", (XtPointer) XmCR_CANCEL },
  { "XmCR_CASCADING", (XtPointer) XmCR_CASCADING },
  { "XmCR_CLIPBOARD_DATA_DELETE", (XtPointer) XmCR_CLIPBOARD_DATA_DELETE },
  { "XmCR_CLIPBOARD_DATA_REQUEST", (XtPointer) XmCR_CLIPBOARD_DATA_REQUEST },
  { "XmCR_COMMAND_CHANGED", (XtPointer) XmCR_COMMAND_CHANGED },
  { "XmCR_COMMAND_ENTERED", (XtPointer) XmCR_COMMAND_ENTERED },
  { "XmCR_CREATE", (XtPointer) XmCR_CREATE },
  { "XmCR_DECREMENT", (XtPointer) XmCR_DECREMENT },
  { "XmCR_DEFAULT_ACTION", (XtPointer) XmCR_DEFAULT_ACTION },
  { "XmCR_DISARM", (XtPointer) XmCR_DISARM },
  { "XmCR_DRAG", (XtPointer) XmCR_DRAG },
  { "XmCR_DUMMY13", (XtPointer) XmCR_DUMMY13 },
  { "XmCR_DUMMY14", (XtPointer) XmCR_DUMMY14 },
  { "XmCR_DUMMY15", (XtPointer) XmCR_DUMMY15 },
  { "XmCR_DUMMY33", (XtPointer) XmCR_DUMMY33 },
  { "XmCR_EXECUTE", (XtPointer) XmCR_EXECUTE },
  { "XmCR_EXPOSE", (XtPointer) XmCR_EXPOSE },
  { "XmCR_EXTENDED_SELECT", (XtPointer) XmCR_EXTENDED_SELECT },
  { "XmCR_FOCUS", (XtPointer) XmCR_FOCUS },
  { "XmCR_GAIN_PRIMARY", (XtPointer) XmCR_GAIN_PRIMARY },
  { "XmCR_HELP", (XtPointer) XmCR_HELP },
  { "XmCR_INCREMENT", (XtPointer) XmCR_INCREMENT },
  { "XmCR_INPUT", (XtPointer) XmCR_INPUT },
  { "XmCR_LOSE_PRIMARY", (XtPointer) XmCR_LOSE_PRIMARY },
  { "XmCR_LOSING_FOCUS", (XtPointer) XmCR_LOSING_FOCUS },
  { "XmCR_MAP", (XtPointer) XmCR_MAP },
  { "XmCR_MODIFYING_TEXT_VALUE", (XtPointer) XmCR_MODIFYING_TEXT_VALUE },
  { "XmCR_MOVING_INSERT_CURSOR", (XtPointer) XmCR_MOVING_INSERT_CURSOR },
  { "XmCR_MULTIPLE_SELECT", (XtPointer) XmCR_MULTIPLE_SELECT },
  { "XmCR_NONE", (XtPointer) XmCR_NONE },
  { "XmCR_NO_MATCH", (XtPointer) XmCR_NO_MATCH },
  { "XmCR_OBSCURED_TRAVERSAL", (XtPointer) XmCR_OBSCURED_TRAVERSAL },
  { "XmCR_OK", (XtPointer) XmCR_OK },
  { "XmCR_PAGE_DECREMENT", (XtPointer) XmCR_PAGE_DECREMENT },
  { "XmCR_PAGE_INCREMENT", (XtPointer) XmCR_PAGE_INCREMENT },
  { "XmCR_PROTOCOLS", (XtPointer) XmCR_PROTOCOLS },
  { "XmCR_RESIZE", (XtPointer) XmCR_RESIZE },
  { "XmCR_SINGLE_SELECT", (XtPointer) XmCR_SINGLE_SELECT },
  { "XmCR_TEAR_OFF_ACTIVATE", (XtPointer) XmCR_TEAR_OFF_ACTIVATE },
  { "XmCR_TEAR_OFF_DEACTIVATE", (XtPointer) XmCR_TEAR_OFF_DEACTIVATE },
  { "XmCR_TO_BOTTOM", (XtPointer) XmCR_TO_BOTTOM },
  { "XmCR_TO_TOP", (XtPointer) XmCR_TO_TOP },
  { "XmCR_UNMAP", (XtPointer) XmCR_UNMAP },
  { "XmCR_VALUE_CHANGED", (XtPointer) XmCR_VALUE_CHANGED },
  { "XmCURSOR", (XtPointer) XmCURSOR },
  { "XmDEFAULT_BACKGROUND", (XtPointer) XmDEFAULT_BACKGROUND },
  { "XmDEFAULT_DARK_THRESHOLD", (XtPointer) XmDEFAULT_DARK_THRESHOLD },
  { "XmDEFAULT_FONT", (XtPointer) XmDEFAULT_FONT },
  { "XmDEFAULT_FOREGROUND_THRESHOLD", (XtPointer) XmDEFAULT_FOREGROUND_THRESHOLD },
  { "XmDEFAULT_LIGHT_THRESHOLD", (XtPointer) XmDEFAULT_LIGHT_THRESHOLD },
  { "XmDESTROY", (XtPointer) XmDESTROY },
  { "XmDIALOG_APPLICATION_MODAL", (XtPointer) XmDIALOG_APPLICATION_MODAL },
  { "XmDIALOG_APPLY_BUTTON", (XtPointer) XmDIALOG_APPLY_BUTTON },
  { "XmDIALOG_CANCEL_BUTTON", (XtPointer) XmDIALOG_CANCEL_BUTTON },
  { "XmDIALOG_COMMAND", (XtPointer) XmDIALOG_COMMAND },
  { "XmDIALOG_COMMAND_TEXT", (XtPointer) XmDIALOG_COMMAND_TEXT },
  { "XmDIALOG_DEFAULT_BUTTON", (XtPointer) XmDIALOG_DEFAULT_BUTTON },
  { "XmDIALOG_DIR_LIST", (XtPointer) XmDIALOG_DIR_LIST },
  { "XmDIALOG_DIR_LIST_LABEL", (XtPointer) XmDIALOG_DIR_LIST_LABEL },
  { "XmDIALOG_ERROR", (XtPointer) XmDIALOG_ERROR },
  { "XmDIALOG_FILE_LIST", (XtPointer) XmDIALOG_FILE_LIST },
  { "XmDIALOG_FILE_LIST_LABEL", (XtPointer) XmDIALOG_FILE_LIST_LABEL },
  { "XmDIALOG_FILE_SELECTION", (XtPointer) XmDIALOG_FILE_SELECTION },
  { "XmDIALOG_FILTER_LABEL", (XtPointer) XmDIALOG_FILTER_LABEL },
  { "XmDIALOG_FILTER_TEXT", (XtPointer) XmDIALOG_FILTER_TEXT },
  { "XmDIALOG_FULL_APPLICATION_MODAL", (XtPointer) XmDIALOG_FULL_APPLICATION_MODAL },
  { "XmDIALOG_HELP_BUTTON", (XtPointer) XmDIALOG_HELP_BUTTON },
  { "XmDIALOG_HISTORY_LIST", (XtPointer) XmDIALOG_HISTORY_LIST },
  { "XmDIALOG_INFORMATION", (XtPointer) XmDIALOG_INFORMATION },
  { "XmDIALOG_LIST", (XtPointer) XmDIALOG_LIST },
  { "XmDIALOG_LIST_LABEL", (XtPointer) XmDIALOG_LIST_LABEL },
  { "XmDIALOG_MESSAGE", (XtPointer) XmDIALOG_MESSAGE },
  { "XmDIALOG_MESSAGE_LABEL", (XtPointer) XmDIALOG_MESSAGE_LABEL },
  { "XmDIALOG_MODELESS", (XtPointer) XmDIALOG_MODELESS },
  { "XmDIALOG_NONE", (XtPointer) XmDIALOG_NONE },
  { "XmDIALOG_OK_BUTTON", (XtPointer) XmDIALOG_OK_BUTTON },
  { "XmDIALOG_PRIMARY_APPLICATION_MODAL", (XtPointer) XmDIALOG_PRIMARY_APPLICATION_MODAL },
  { "XmDIALOG_PROMPT", (XtPointer) XmDIALOG_PROMPT },
  { "XmDIALOG_PROMPT_LABEL", (XtPointer) XmDIALOG_PROMPT_LABEL },
  { "XmDIALOG_QUESTION", (XtPointer) XmDIALOG_QUESTION },
  { "XmDIALOG_SELECTION", (XtPointer) XmDIALOG_SELECTION },
  { "XmDIALOG_SELECTION_LABEL", (XtPointer) XmDIALOG_SELECTION_LABEL },
  { "XmDIALOG_SEPARATOR", (XtPointer) XmDIALOG_SEPARATOR },
  { "XmDIALOG_SYMBOL_LABEL", (XtPointer) XmDIALOG_SYMBOL_LABEL },
  { "XmDIALOG_SYSTEM_MODAL", (XtPointer) XmDIALOG_SYSTEM_MODAL },
  { "XmDIALOG_TEMPLATE", (XtPointer) XmDIALOG_TEMPLATE },
  { "XmDIALOG_TEXT", (XtPointer) XmDIALOG_TEXT },
  { "XmDIALOG_VALUE_TEXT", (XtPointer) XmDIALOG_VALUE_TEXT },
  { "XmDIALOG_WARNING", (XtPointer) XmDIALOG_WARNING },
  { "XmDIALOG_WORKING", (XtPointer) XmDIALOG_WORKING },
  { "XmDIALOG_WORK_AREA", (XtPointer) XmDIALOG_WORK_AREA },
  { "XmDOUBLE_DASHED_LINE", (XtPointer) XmDOUBLE_DASHED_LINE },
  { "XmDOUBLE_LINE", (XtPointer) XmDOUBLE_LINE },
  { "XmDOUBLE_SEPARATOR", (XtPointer) XmDOUBLE_SEPARATOR },
  { "XmDO_NOTHING", (XtPointer) XmDO_NOTHING },
  { "XmDYNAMIC", (XtPointer) XmDYNAMIC },
  { "XmEXCLUSIVE_TAB_GROUP", (XtPointer) XmEXCLUSIVE_TAB_GROUP },
  { "XmEXPLICIT", (XtPointer) XmEXPLICIT },
  { "XmEXTENDED_SELECT", (XtPointer) XmEXTENDED_SELECT },
  { "XmFALLBACK_CHARSET", (XtPointer) XmFALLBACK_CHARSET },
  { "XmFILE_ANY_TYPE", (XtPointer) XmFILE_ANY_TYPE },
  { "XmFILE_DIRECTORY", (XtPointer) XmFILE_DIRECTORY },
  { "XmFILE_REGULAR", (XtPointer) XmFILE_REGULAR },
  { "XmFIRST_POSITION", (XtPointer) XmFIRST_POSITION },
  { "XmFMT_16_BIT", (XtPointer) XmFMT_16_BIT },
  { "XmFMT_8_BIT", (XtPointer) XmFMT_8_BIT },
  { "XmFONT_IS_FONT", (XtPointer) XmFONT_IS_FONT },
  { "XmFONT_IS_FONTSET", (XtPointer) XmFONT_IS_FONTSET },
  { "XmFRAME_GENERIC_CHILD", (XtPointer) XmFRAME_GENERIC_CHILD },
  { "XmFRAME_TITLE_CHILD", (XtPointer) XmFRAME_TITLE_CHILD },
  { "XmFRAME_WORKAREA_CHILD", (XtPointer) XmFRAME_WORKAREA_CHILD },
  { "XmHIGHLIGHT_NORMAL", (XtPointer) XmHIGHLIGHT_NORMAL },
  { "XmHIGHLIGHT_SECONDARY_SELECTED", (XtPointer) XmHIGHLIGHT_SECONDARY_SELECTED },
  { "XmHIGHLIGHT_SELECTED", (XtPointer) XmHIGHLIGHT_SELECTED },
  { "XmHORIZONTAL", (XtPointer) XmHORIZONTAL },
  { "XmINHERIT_POLICY", (XtPointer) XmINHERIT_POLICY },
  { "XmINVALID_SEPARATOR_TYPE", (XtPointer) XmINVALID_SEPARATOR_TYPE },
  { "XmLAST_POSITION", (XtPointer) XmLAST_POSITION },
  { "XmMAX_ON_BOTTOM", (XtPointer) XmMAX_ON_BOTTOM },
  { "XmMAX_ON_LEFT", (XtPointer) XmMAX_ON_LEFT },
  { "XmMAX_ON_RIGHT", (XtPointer) XmMAX_ON_RIGHT },
  { "XmMAX_ON_TOP", (XtPointer) XmMAX_ON_TOP },
  { "XmMENU_BAR", (XtPointer) XmMENU_BAR },
  { "XmMENU_OPTION", (XtPointer) XmMENU_OPTION },
  { "XmMENU_POPUP", (XtPointer) XmMENU_POPUP },
  { "XmMENU_PULLDOWN", (XtPointer) XmMENU_PULLDOWN },
  { "XmMULTICLICK_DISCARD", (XtPointer) XmMULTICLICK_DISCARD },
  { "XmMULTICLICK_KEEP", (XtPointer) XmMULTICLICK_KEEP },
  { "XmMULTIPLE_SELECT", (XtPointer) XmMULTIPLE_SELECT },
  { "XmMULTI_LINE_EDIT", (XtPointer) XmMULTI_LINE_EDIT },
  { "XmNONE", (XtPointer) XmNONE },
  { "XmNO_LINE", (XtPointer) XmNO_LINE },
  { "XmNO_ORIENTATION", (XtPointer) XmNO_ORIENTATION },
  { "XmNO_PACKING", (XtPointer) XmNO_PACKING },
  { "XmN_OF_MANY", (XtPointer) XmN_OF_MANY },
  { "XmONE_OF_MANY", (XtPointer) XmONE_OF_MANY },
  { "XmPACK_COLUMN", (XtPointer) XmPACK_COLUMN },
  { "XmPACK_NONE", (XtPointer) XmPACK_NONE },
  { "XmPACK_TIGHT", (XtPointer) XmPACK_TIGHT },
  { "XmPER_SHELL", (XtPointer) XmPER_SHELL },
  { "XmPER_WIDGET", (XtPointer) XmPER_WIDGET },
  { "XmPIXELS", (XtPointer) XmPIXELS },
  { "XmPIXMAP", (XtPointer) XmPIXMAP },
  { "XmPLACE_ABOVE_SELECTION", (XtPointer) XmPLACE_ABOVE_SELECTION },
  { "XmPLACE_BELOW_SELECTION", (XtPointer) XmPLACE_BELOW_SELECTION },
  { "XmPLACE_TOP", (XtPointer) XmPLACE_TOP },
  { "XmPOINTER", (XtPointer) XmPOINTER },
  { "XmPUSHBUTTON", (XtPointer) XmPUSHBUTTON },
  { "XmRADIOBUTTON", (XtPointer) XmRADIOBUTTON },
  { "XmRESIZE_ANY", (XtPointer) XmRESIZE_ANY },
  { "XmRESIZE_GROW", (XtPointer) XmRESIZE_GROW },
  { "XmRESIZE_IF_POSSIBLE", (XtPointer) XmRESIZE_IF_POSSIBLE },
  { "XmRESIZE_NONE", (XtPointer) XmRESIZE_NONE },
  { "XmREVISION", (XtPointer) XmREVISION },
  { "XmSELECT_ALL", (XtPointer) XmSELECT_ALL },
  { "XmSELECT_LINE", (XtPointer) XmSELECT_LINE },
  { "XmSELECT_PARAGRAPH", (XtPointer) XmSELECT_PARAGRAPH },
  { "XmSELECT_POSITION", (XtPointer) XmSELECT_POSITION },
  { "XmSELECT_WHITESPACE", (XtPointer) XmSELECT_WHITESPACE },
  { "XmSELECT_WORD", (XtPointer) XmSELECT_WORD },
  { "XmSEPARATOR", (XtPointer) XmSEPARATOR },
  { "XmSHADOW_ETCHED_IN", (XtPointer) XmSHADOW_ETCHED_IN },
  { "XmSHADOW_ETCHED_IN_DASH", (XtPointer) XmSHADOW_ETCHED_IN_DASH },
  { "XmSHADOW_ETCHED_OUT", (XtPointer) XmSHADOW_ETCHED_OUT },
  { "XmSHADOW_ETCHED_OUT_DASH", (XtPointer) XmSHADOW_ETCHED_OUT_DASH },
  { "XmSHADOW_IN", (XtPointer) XmSHADOW_IN },
  { "XmSHADOW_OUT", (XtPointer) XmSHADOW_OUT },
  { "XmSINGLE_DASHED_LINE", (XtPointer) XmSINGLE_DASHED_LINE },
  { "XmSINGLE_LINE", (XtPointer) XmSINGLE_LINE },
  { "XmSINGLE_LINE_EDIT", (XtPointer) XmSINGLE_LINE_EDIT },
  { "XmSINGLE_SELECT", (XtPointer) XmSINGLE_SELECT },
  { "XmSTATIC", (XtPointer) XmSTATIC },
  { "XmSTICKY_TAB_GROUP", (XtPointer) XmSTICKY_TAB_GROUP },
  { "XmSTRING", (XtPointer) XmSTRING },
  { "XmSTRING_COMPONENT_CHARSET", (XtPointer) XmSTRING_COMPONENT_CHARSET },
  { "XmSTRING_COMPONENT_DIRECTION", (XtPointer) XmSTRING_COMPONENT_DIRECTION },
  { "XmSTRING_COMPONENT_END", (XtPointer) XmSTRING_COMPONENT_END },
  { "XmSTRING_COMPONENT_LOCALE_TEXT", (XtPointer) XmSTRING_COMPONENT_LOCALE_TEXT },
  { "XmSTRING_COMPONENT_SEPARATOR", (XtPointer) XmSTRING_COMPONENT_SEPARATOR },
  { "XmSTRING_COMPONENT_TEXT", (XtPointer) XmSTRING_COMPONENT_TEXT },
  { "XmSTRING_COMPONENT_UNKNOWN", (XtPointer) XmSTRING_COMPONENT_UNKNOWN },
  { "XmSTRING_COMPONENT_USER_BEGIN", (XtPointer) XmSTRING_COMPONENT_USER_BEGIN },
  { "XmSTRING_COMPONENT_USER_END", (XtPointer) XmSTRING_COMPONENT_USER_END },
  { "XmSTRING_DIRECTION_DEFAULT", (XtPointer) XmSTRING_DIRECTION_DEFAULT },
  { "XmSTRING_DIRECTION_L_TO_R", (XtPointer) XmSTRING_DIRECTION_L_TO_R },
  { "XmSTRING_DIRECTION_R_TO_L", (XtPointer) XmSTRING_DIRECTION_R_TO_L },
  { "XmSTRING_OS_CHARSET", (XtPointer) XmSTRING_OS_CHARSET },
  { "XmTAB_GROUP", (XtPointer) XmTAB_GROUP },
  { "XmTEAR_OFF_DISABLED", (XtPointer) XmTEAR_OFF_DISABLED },
  { "XmTEAR_OFF_ENABLED", (XtPointer) XmTEAR_OFF_ENABLED },
  { "XmTEXT_BACKWARD", (XtPointer) XmTEXT_BACKWARD },
  { "XmTEXT_FORWARD", (XtPointer) XmTEXT_FORWARD },
  { "XmTITLE", (XtPointer) XmTITLE },
  { "XmTOGGLEBUTTON", (XtPointer) XmTOGGLEBUTTON },
  { "XmTOP_LEFT", (XtPointer) XmTOP_LEFT },
  { "XmTOP_RIGHT", (XtPointer) XmTOP_RIGHT },
  { "XmTRAVERSE_CURRENT", (XtPointer) XmTRAVERSE_CURRENT },
  { "XmTRAVERSE_DOWN", (XtPointer) XmTRAVERSE_DOWN },
  { "XmTRAVERSE_HOME", (XtPointer) XmTRAVERSE_HOME },
  { "XmTRAVERSE_LEFT", (XtPointer) XmTRAVERSE_LEFT },
  { "XmTRAVERSE_NEXT", (XtPointer) XmTRAVERSE_NEXT },
  { "XmTRAVERSE_NEXT_TAB_GROUP", (XtPointer) XmTRAVERSE_NEXT_TAB_GROUP },
  { "XmTRAVERSE_PREV", (XtPointer) XmTRAVERSE_PREV },
  { "XmTRAVERSE_PREV_TAB_GROUP", (XtPointer) XmTRAVERSE_PREV_TAB_GROUP },
  { "XmTRAVERSE_RIGHT", (XtPointer) XmTRAVERSE_RIGHT },
  { "XmTRAVERSE_UP", (XtPointer) XmTRAVERSE_UP },
  { "XmUNMAP", (XtPointer) XmUNMAP },
  { "XmUNPOST", (XtPointer) XmUNPOST },
  { "XmUNPOST_AND_REPLAY", (XtPointer) XmUNPOST_AND_REPLAY },
  { "XmUNSPECIFIED", (XtPointer) XmUNSPECIFIED },
  { "XmUNSPECIFIED_PIXMAP", (XtPointer) XmUNSPECIFIED_PIXMAP },
  { "XmVARIABLE", (XtPointer) XmVARIABLE },
  { "XmVERSION", (XtPointer) XmVERSION },
  { "XmVERSION_STRING", (XtPointer) XmVERSION_STRING },
  { "XmVERTICAL", (XtPointer) XmVERTICAL },
  { "XmVISIBILITY_FULLY_OBSCURED", (XtPointer) XmVISIBILITY_FULLY_OBSCURED },
  { "XmVISIBILITY_PARTIALLY_OBSCURED", (XtPointer) XmVISIBILITY_PARTIALLY_OBSCURED },
  { "XmVISIBILITY_UNOBSCURED", (XtPointer) XmVISIBILITY_UNOBSCURED },
  { "XmVersion", (XtPointer) XmVersion },
  { "XmWINDOW", (XtPointer) XmWINDOW },
  { "XmWORK_AREA", (XtPointer) XmWORK_AREA },
};

int ClassSize = sizeof(CreateFunctions)/sizeof(CreateFunctions[0]);
int ArgSize = sizeof(ArgNames)/sizeof(ArgNames[0]);  
int PreSize = sizeof(Predefines)/sizeof(Predefines[0]);  
