/**
 *
 * $Id: Control.c,v 1.1.1.1 1996/08/06 05:51:34 toshok Exp $
 *
 * Copyright (C) 1995, 1996 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char *rcsid = "$Id: Control.c,v 1.1.1.1 1996/08/06 05:51:34 toshok Exp $";

#include <stdio.h>
#include "UilMrm.h"
#include "Tree.h"

YYSTYPE
ControlListEmpty()
{
	uil_objects_t *e = (uil_objects_t *)XtMalloc(sizeof(uil_objects_t));

	e->type = s_controls;
	e->name = NULL;
	e->left = e->right = NULL;

	e->arguments = NULL;
	e->controls = NULL;
	e->callbacks = NULL;

	return e;
}

/*
 * This is a destructive operation : l1 gets modified, and l2 would be used twice
 * if you'd use it separately
 */
YYSTYPE
ControlListAppend(YYSTYPE l1, YYSTYPE l2)
{
	tree	t1 = (tree)l1, t2 = (tree)l2, t;

	for (t=t1; t->right != NULL; t = t->right) ;
	t->right = t2;

	return t1;
}

YYSTYPE
ControlListFromList(char *n)
{
	return NULL;
}

YYSTYPE
ControlListObject(char *n, uil_objects_t *o)
{
	uil_controls_t	*r = (uil_controls_t *)XtMalloc(sizeof(uil_controls_t));

	r->type = s_controls;
	r->name = XtNewString(n);
	r->left = r->right = NULL;
	r->object = o;
}

void
ControlListPrint(FILE *o, tree l)
{
	uil_controls_t	*p = (uil_controls_t *)l;

	fprintf(o, "<CTRL>%s\n", p->name);
}
