/**
 *
 * $Id: Mrm.c,v 1.2 1996/08/14 05:45:11 u27113 Exp $
 * 
 * Copyright (C) 1995 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char rcsid[] = "$Id: Mrm.c,v 1.2 1996/08/14 05:45:11 u27113 Exp $";

#include <Mrm/MrmPrivate.h>

#include <XmI/DebugUtil.h>

#include <stdarg.h>
#include "uil.h"
#include "lookup.h"
#include "misc.h"

typedef struct _SymbolTable {
  struct _SymbolTable *Next;
  int type;
  char *Name;
  XtPointer *value;
} SymbolTableType;

SymbolTableType *GetSymbolTable(SymbolTableType *);
SymbolTableType *LookupValue(SymbolTableType *SymbolTable, char *name);

typedef struct _UilModuleType {
  char **Definitions;
  char **Names;
  int NumberOfWidgets;
  Widget *WidgetArray;
  SymbolTableType *SymbolTable;
} UilModuleType;

SymbolTableType *GlobalSymbolTable;
int NumberFiles;    

#define MAX_HIER 20

char *GetString(char *location, char **source);

UilModuleType UilModule[MAX_HIER];
  Arg *args;
  int MaxArgCount = 40; /* FIX ME  -- this needs to come out of the file */

int NumberRegisteredFunctions;
extern MrmRegisterArg *RegisteredFunctions;
XmString DecodeComplexString(char *value);

#if 0
void MrmInitialize ()
{
}
#endif

int ParseLoadWidgets(UilModuleType *Module)
{
  char c;
  int i, id, index;
  int this_id, class_id, parent,child_id;
  char *string, Registered[256];
  long value;
  char temp[256];
  char **WidgetDefinitions = Module->Definitions;
  char **WidgetNames = Module->Names;

  c = getc(stdin);
  i = 0;
  while (c == MrmRtypeClassRecName) {
    string = WidgetDefinitions[i++] = (char *) malloc(2048);
    index = 0;
    if ((*string++ = c = getchar()) != '"')
      Exit(LOC, "Widget's Name Expected\n");
    for (c = getchar(); c != '"'; c = getchar()) /* Widget Name */{
      temp[index++] = *string++ = c;
    }
    temp[index] = 0;
    *string++ = '"';
    this_id = *string++ = getchar(); /* this */
    if (this_id == 5)
      XdbDebug(__FILE__, NULL,"");
    class_id = *string++ = getchar(); /* class */
    parent = *string++ = getchar(); /* parent */
    XdbDebug(__FILE__, NULL, "Widget[%d]=CreateFunctions[%d].function(parent,\"%s\",NULL,0);\n",
	   this_id, class_id, temp);
    while (child_id = *string++ = getchar()) { /* children */
      XdbDebug(__FILE__, NULL, "if (MrmSUCCESS != MrmFetchWidget(hierarchy_id,%s,Widget[%d],&child, &type)) { return (MrmFAILURE); }\n",WidgetNames[child_id-1],this_id);
    }
    c = getchar();
    for (; c == MrmRtypeCallback; c = getchar()) { /* callbacks */
      XdbDebug(__FILE__, NULL, "XtAddCallback(");
      id = *string++ = c;
      *string++ = getchar();
      *string = getchar();
      if (*string != '"')
	Exit(LOC, "String Expected for arg Name in callback\n");
      string++;
      index = 0;
      for (c = getchar(); c != '"'; c = getchar())
	temp[index++] = *string++ = c;
      temp[index] = 0;
      *string++ = c;
      index = 0;
      *string = getchar();
      if (*string++ != '"')
	Exit(LOC, "String Expected for function Name in callback\n");
      for (c = getchar(); c != '"'; c = getchar()) 
	Registered[index++] = *string++ = c;
      *string++ = c;
      Registered[index] = 0;
      XdbDebug(__FILE__, NULL, "%s, \"%s\"", CreateFunctions[id].Name, temp);
      XdbDebug(__FILE__, NULL, ",LookUpRegisteredFunction(\"%s\");\n", Registered);
    }
    for (; c == MrmRtypeResource; c = getchar()) { /* Attributes */
      *string++ = c;
      *string++ = c = getchar();
      index = 0;
      if (c != '"')
	Exit(LOC, "Argument's Name Expected in ArgList\n");
      for (c = getchar(); c != '"'; c = getchar())
	temp[index++] = *string++ = c;
      *string++ = c;
      temp[index] = 0;
      XdbDebug(__FILE__, NULL, "XtSetArg(args[n], \"%s\", ",temp);
      *string++ = c = getchar();
      switch(c) {
      case MrmRtypeXBitmapFile: {
	int SizeOfData;
	BitMapType *bitmap;

	bitmap = (BitMapType *)string;
	fread(bitmap, sizeof(BitMapType)-sizeof(long), 1, stdin);
	SizeOfData = bitmap->width*bitmap->height>>3;
	bitmap->data = (char *)malloc(SizeOfData);
	fread(bitmap->data, sizeof(char), SizeOfData, stdin);
	string += sizeof(BitMapType);
	break;
      }
      case MrmRtypeKeysym:
      case MrmRtypeInteger:
      case MrmRtypeBoolean:
	*string++ = getchar();	
	*string++ = getchar();
	*string++ = getchar();
	*string++ = getchar();
	memcpy(&value,string,sizeof(value));
	XdbDebug(__FILE__, NULL, "%ld);n++;\n",value);
	break;
      case MrmRtypeChar8:
      case MrmRtypeAddrName:
      case MrmRtypeCString:
	index = 0;
	while (temp[index++] = *string++ = getchar());
	temp[index] = 0;
	XdbDebug(__FILE__, NULL, "%s);n++;\n",temp);
	break;
      default:
	Exit(LOC, "Unknown Attribute type: %d\n",c);
      }
    }
    XdbDebug(__FILE__, NULL, "\n");
  }
  if (c != EOF)
    Exit(LOC, "Error in UID: New Widget code not found before End of File\n");
  return i;
}

#define MAX_DEF 2048
#define MAX_STR 256

#if 0
Cardinal
MrmOpenHierarchy(MrmCount num_files,
		String *name_list,
		MrmOsOpenParamPtr *os_ext_list,
		MrmHierarchy *hierarchy_id_return)
{
  int DefCounter = 0;
  int fileIndex;
  int NumberOfWidgets;
  char c, *string;
  int i;
  char **WidgetDefinitions;
  char **WidgetNames;
  /*
     MrmSUCCESS     The function executed successfully.
     
     MrmFAILURE     The function failed.
     */
  NumberFiles = num_files;

  args = (Arg *) malloc(sizeof (Arg) * MaxArgCount);
  
  for (fileIndex = 0; fileIndex < num_files; fileIndex++) {
    if (NULL == freopen(name_list[fileIndex],"r",stdin)) {
      Exit(LOC, name_list[fileIndex]);
    }
    fread(&NumberOfWidgets,sizeof(int), 1, stdin);
NumberOfWidgets=1000;  
    UilModule[fileIndex].Names = WidgetNames = 
      (char **)malloc(sizeof(char *) * NumberOfWidgets);
    if (NULL == WidgetNames){
      Exit(LOC,"malloc: %s\n", strerror(errno));
    }
    for (i = 0; (((c = getc(stdin)) != EOF) && (c == '"'));i++) {
      string = WidgetNames[i] = (char *)malloc(256);
      DefCounter = 0;
      while(((c = getc(stdin)) != EOF) && (c != '"')){
	*string++ = c;
	DefCounter++;
	if (DefCounter >= MAX_STR) {
	  Exit(LOC, "String def too long\n");
	}
      }
      *string = 0;
    }
    if (c) {
      Exit(LOC, "ERROR in header\n");
    }
    GlobalSymbolTable = GetSymbolTable(GlobalSymbolTable);  /*Append to exist*/
    UilModule[fileIndex].SymbolTable = GetSymbolTable(NULL); /* Always new   */

    UilModule[fileIndex].Definitions = WidgetDefinitions = 
      (char **) malloc(sizeof(char *) * NumberOfWidgets);
    ParseLoadWidgets(&UilModule[fileIndex]);
    UilModule[fileIndex].NumberOfWidgets = i;
    UilModule[fileIndex].WidgetArray = 
      (Widget *) malloc(sizeof(Widget) * NumberOfWidgets);

  }
  return MrmSUCCESS;
}
#endif

Cardinal MrmRegisterNames(MrmRegisterArglist reglist, MrmCount num_reg)
{
/*
       MrmSUCCESS     The function executed successfully.

       MrmFAILURE     The function failed.
*/
	NumberRegisteredFunctions = num_reg;
	RegisteredFunctions = reglist;
	return MrmSUCCESS;
}

Cardinal MrmFetchLiteral(MrmHierarchy hierarchy_id, String index, Display *display, XtPointer *value, MrmCode *type)
{
  SymbolTableType *symbol;
/*
   MrmBAD_HIERARCHY
   MrmNOT_FOUND
   MrmWRONG_TYPE
   MrmFAILURE
*/
  for (symbol = GlobalSymbolTable; symbol; symbol = symbol->Next)
    if (strcmp(index, symbol->Name) == 0) {
      *value = (XtPointer ) symbol->value;
      if (*type != symbol->type)
	return MrmWRONG_TYPE;
      return MrmSUCCESS;
    }
  return MrmNOT_FOUND;
}
 
Cardinal MrmFetchWidgetOverride(MrmHierarchy hierarchy_id, String index, Widget parent_widget, String override_name, ArgList override_args, Cardinal override_num_args, Widget *widget, MrmType *class)
{
  Cardinal returnValue = 
    MrmFetchWidget(hierarchy_id, index, parent_widget, widget,class);
  XtSetValues(*widget,override_args,override_num_args);
  return returnValue;
}

Cardinal MrmFetchWidget(MrmHierarchy hierarchy_id, String index, Widget parent_widget, Widget *widget, MrmType *class)
{
  char *string;
  char Name[256];
  char this_id, class_id, parent_id, child_id;  
  int c;
  char id;
  int i = 0;
  int k, n;
  int module_id;
  Widget child;
  MrmType type;
  Bool Found = False;
  int file;
  Widget myWidget;
  static SymbolTableType *FormSymbolTable =NULL, *CurrentFormSymbolTable=NULL; 
  static SymbolTableType *LastFormSymbolTable = NULL;

/*FIXME  FormSymbolTable should be cleared/reset on entering with XmForm or
XmBulletinBoard type*/

XdbDebug(__FILE__, parent_widget, "Fetch %s\n",index);

  for (file = 0; !Found && (file < NumberFiles); file++) {
    for ( k = 0; k < UilModule[file].NumberOfWidgets; k++){
	XdbDebug(__FILE__, parent_widget, "Compare '%s' to '%s'\n",
		index, UilModule[file].Names[k]);

      if (strcmp(index,UilModule[file].Names[k]) == 0) {
	module_id = file;
	Found = True;
	break;
      }
    }
  }
  if (!Found) {
    XdbDebug(__FILE__, parent_widget,"Fetch return Not FOUND\n");
    return (MrmNOT_FOUND);
  } 
  string = UilModule[module_id].Definitions[k];
  GetString(Name, &string);
  XdbDebug(__FILE__, parent_widget, "/* %s */\n",Name);
  this_id = *string++;
  class_id = *string++;
  parent_id = *string++;
  myWidget = CreateFunctions[class_id].function(parent_widget,Name,NULL,0);
  if (NULL == myWidget){
    Exit(LOC, "Couldn't create widget %s",Name);
  }
  UilModule[module_id].WidgetArray[this_id-1] = myWidget;
  while (child_id = *string++) {
    Cardinal returnCode;

XdbDebug(__FILE__, parent_widget,"MrmFetchWidget(%d,%s,Widget[%s],&child,&type);\n",
hierarchy_id,UilModule[module_id].Names[child_id-1],
UilModule[module_id].Names[this_id-1]);
    if (MrmSUCCESS != (returnCode = MrmFetchWidget(hierarchy_id,
				     UilModule[module_id].Names[child_id-1],
				     UilModule[module_id].
						   WidgetArray[this_id-1],
				     &child, &type))) { 
      return (returnCode); 
    }
    CurrentFormSymbolTable =(SymbolTableType *)malloc(sizeof(SymbolTableType));
    if (NULL == FormSymbolTable)
      FormSymbolTable = CurrentFormSymbolTable;
    if (LastFormSymbolTable)
      LastFormSymbolTable->Next = CurrentFormSymbolTable;
    CurrentFormSymbolTable->value = (XtPointer)child;
    CurrentFormSymbolTable->Name = UilModule[module_id].Names[child_id-1];
    CurrentFormSymbolTable->Next = NULL;
    LastFormSymbolTable = CurrentFormSymbolTable;
    if (0 == strcmp(CreateFunctions[class_id].Name,"XmCascadeButton")) {
      XtSetArg(args[0], XmNsubMenuId, child);
      XtSetValues(UilModule[module_id].WidgetArray[this_id-1],args,1);
    }
    XtManageChild(child);
  }
  GetCallbacks(module_id, this_id-1, &string);
  GetAttributes( myWidget, module_id, &n, args, &string, FormSymbolTable);
  XtSetValues(*widget = UilModule[module_id].WidgetArray[this_id-1], args, n);
XdbDebug(__FILE__, parent_widget,"Fetch SUCCESS\n");
  return MrmSUCCESS;
}

char *GetString(char *location, char **sourceString)
{	
  char *source = *sourceString;
  int c,i;
  char *temp;
  static char localSpace[256];

  if ( NULL == location )
  	temp = localSpace;
  else
  	temp = location;
  c = *source++;
  if (c != '\"'){
    Exit(LOC, "BAD STRING\n");
  }
  i = 0;
  while (*source && (*source != '"'))
  	temp[i++] = *source++;
  temp[i] = 0;
  *sourceString = ++source;
  return temp;
}

GetCallbacks(int fileno, int wid_id, char **SourceString)
{
  char id, ch;
  char *source = *SourceString;
  int nameIndex = 0;
  char CallbackFunctionName[256], CallbackType[256];

  while (*source == MrmRtypeCallback) {
    source++;
    id = *source++;
    GetString(CallbackType,&source);
    GetString(CallbackFunctionName,&source);
    XtAddCallback(UilModule[fileno].WidgetArray[wid_id], CallbackType,
		  (XtCallbackProc) LookUpFunction(CallbackFunctionName),
		  NULL);

  }
  *SourceString = source;
  return;
}

GetAttributes(Widget wid, int module_id, int *n, Arg *args, 
	      char **SourceString, SymbolTableType *FormSymbolTable)
{
  char ch;
  XtArgVal value;
  int i;
  char *temp;
  char *source = *SourceString;
  char *Name;
  SymbolTableType *SymbolTable;
  BitMapType *bitmap;

  *n = 0;
  while (MrmRtypeResource == (ch = *source++)) {
    Name = Store(GetString(NULL, &source));
    switch(*source++) {
    case MrmRtypeXBitmapFile: 
      bitmap = (BitMapType *) source;
      value = (long)XCreateBitmapFromData(XtDisplay(wid), 
					  DefaultRootWindow(XtDisplay(wid)), 
					  bitmap->data,
					  bitmap->width, bitmap->height);
      source += sizeof(BitMapType);
      break;
    case MrmRtypeKeysym:
    case MrmRtypeInteger:
    case MrmRtypeBoolean:
      memcpy(&value,source,sizeof(long));
      source += sizeof(long);
      break;
    case MrmRtypeAddrName:
      temp = source++;
      while (*source++);
XdbDebug(__FILE__, wid,"LOOKUP %s ...", temp);
      if ( NULL == 
	  (SymbolTable = LookupValue(UilModule[module_id].SymbolTable, temp))){
	if (NULL == (SymbolTable = LookupValue(GlobalSymbolTable, temp))){
	  if (NULL == (SymbolTable = LookupValue(FormSymbolTable,temp))) {
	    value = (XtArgVal) LookUpPredefines(temp);
	    break;
	  }
	}
      }
      value = (XtArgVal) SymbolTable->value;
XdbDebug(__FILE__, wid,"Found  value = %ld\n",value);
       break;
    case MrmRtypeChar8:
    case MrmRtypeCString:
      temp = source++;
      while (*source++);
      value = (XtArgVal) DecodeComplexString(temp);
      break;
    default:
      Exit(LOC, "UNKNOWN ATTRIBUTE\n");
    }
    XtSetArg(args[*n], Name, value);
    (*n)++;
XdbDebug(__FILE__, wid,"XtSetArg(args[n], %s, %d\n",Name,value);
  }
  *SourceString = source;
}

XmString DecodeComplexString(char *value)
{   
  char tmp[2560];
  char *source = (char *) value;
  int i;
  
  tmp[0] = 0;
  for (i = 0; source[i]; ){
    while (source[i] && source[i] == '\"'){
      char *string1 = &source[i+1];
      for(i=i+1;source[i] != '\"';i++)
	;
      source[i] = 0;
      i++;
      push((char *)XmStringCreate(string1,XmFONTLIST_DEFAULT_TAG));
    }
    if (source[i] == 'S') {
      XmString string1 = (XmString) pop();
      push((char *)XmStringConcat(string1,XmStringSeparatorCreate()));
      i++;
    }
    if (source[i] == 'C') {
      XmString string1 = (XmString) pop();
      XmString string2 = (XmString) pop();

      push((char *)XmStringConcat(string2, string1));
      i++;
    }
  }
  return (XmString) pop();
}

SymbolTableType *GetSymbolTable(SymbolTableType *Table)
{
  char name[256], ch, *temp;
  int i;
  SymbolTableType *NewTable = NULL;
  SymbolTableType *LastTable = NULL;
  
  if (Table)
    for (LastTable = Table; LastTable->Next; LastTable = LastTable->Next)
      ;
  for (ch = getchar(); ch; ch = getchar()) {
    if ('"' != ch) {
      Exit(LOC, "Error in HEADER  ch = %d = %c\n",ch,ch);
    }
    for (i = 0,name[i] = getchar(); name[i++] != '"'; name[i] = getchar());
    name[i-1] = 0;
    NewTable = (SymbolTableType *)malloc(sizeof(SymbolTableType));
    NewTable->Next = NULL;
    if (LastTable) {
      LastTable->Next = NewTable;
    }
    else if (NULL == Table)
      Table = NewTable;
    LastTable = NewTable;
    NewTable->Name = Store(name);
    NewTable->type = getchar();
XdbDebug(__FILE__, NULL,"Name = %s\n",NewTable->Name);
    switch(NewTable->type) {
    case MrmRtypeKeysym:
    case MrmRtypeInteger:
    case MrmRtypeBoolean:
      fread(&NewTable->value,sizeof(long), 1, stdin);
      break;
    case MrmRtypeChar8:
      temp = &name[0];
      while (*temp++ = getchar());
      *(temp-2) = 0;
      NewTable->value = (XtPointer *) XmStringCreateSimple(&name[1]);
      break;
    case MrmRtypeCString:
      temp = &name[0];
      while (*temp++ = getchar());
      NewTable->value = (XtPointer *) DecodeComplexString(name);
      break;
    default:
      Exit(LOC, "UNKNOWN ATTRIBUTE\n");
    }
  }
XdbDebug(__FILE__, NULL,"\n\n");
      
  if (NULL == Table)
    return NewTable;
  else
    return Table;
}

SymbolTableType *
LookupValue(SymbolTableType *SymbolTable, char *name)
{
  while (SymbolTable) {
    if (0 == strcmp(SymbolTable->Name,name))
      return SymbolTable;
    else
      SymbolTable = SymbolTable->Next;
  }
  return NULL;
}

#if 0
Cardinal 
MrmCloseHierarchy(MrmHierarchy hierarchy)
{
    return MrmFAILURE;
}

Cardinal 
MrmOpenHierarchyPerDisplay(Display *display,
			   MrmCount num_files,
			   String file_name_list[],
			   MrmOsOpenParamPtr os_params_list[],
			   MrmHierarchy *hierarchy)
{
    return MrmFAILURE;
}
#endif

Cardinal
MrmRegisterClass(MrmType	class_code,
		 String		class_name,
		 String		create_name,
		 Widget		(*create_proc)(),
		 WidgetClass	class_record)
{
	return MrmFAILURE;
}
		
