/**
 *
 * $Id: lookup.c,v 1.1.1.1 1996/08/06 05:51:33 toshok Exp $
 *
 * Copyright (C) 1995 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

static char rcsid[] = "$Id: lookup.c,v 1.1.1.1 1996/08/06 05:51:33 toshok Exp $";

/*
 * Written by
 *     Geoffrey W. Ritchey
 *
*/
#include "Mrm/MrmPublic.h"
#include <Xm/Text.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>
#include <Xm/Label.h>

#include "misc.h"
#include "lookup.h"

int NumberRegisteredFunctions;
MrmRegisterArg *RegisteredFunctions;

unsigned char LookUpClassIndex(char *ClassName)
{
  int i = 0;
  
  for (i = 0; i < ClassSize; i++)
    if (strcmp( CreateFunctions[i].Name, ClassName) == 0){
      return (unsigned char )i;
    }
  Exit(LOC,"Undefined Class Name: %s\n", ClassName);
  exit(1);
}

unsigned char LookUpArgIndex(char *ArgName)
{
  int i = 0;
  
  for (i = 0; i < ArgSize; i++) {
#if 0
    XdbDebug(__FILE__, NULL, "LookUpArgIndex(%d) - [%s,%s]\n", i,
	ArgNames[i].Name, ArgName);
#endif
    if (strcmp( ArgNames[i].Name, ArgName) == 0){
      return i;
    }
  }
  Exit(LOC,"Undefined Arg Name: %s\n", ArgName);
  /*NOTREACHED*/
}


XtPointer LookUpFunction(String FunctionName)
{
  int i = 0;
  
  for (i = 0; i < NumberRegisteredFunctions; i++)
    if (strcmp( RegisteredFunctions[i].name, FunctionName) == 0){
      return RegisteredFunctions[i].value;
    }
  Exit(LOC, "Could not find %s\n",FunctionName);
  /*NOTREACHED*/
}

XtPointer LookUpPredefines(String Name)
{
  int i = 0;
  
  for (i = 0; i < PreSize; i++)
    if (strcmp( Predefines[i].Name, Name) == 0){
      return Predefines[i].value;
    }
  Exit(LOC, "Could not find %s\n",Name);
  /*NOTREACHED*/
}

