/**
 *
 * $Id: lookup.h,v 1.1.1.1 1996/08/06 05:51:33 toshok Exp $
 *
 * Copyright (C) 1995 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

#ifndef _LOOKUP_H
#define _LOOKUP_H
#include "Mrm/MrmPublic.h"
#include <Xm/Text.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>
#include <Xm/Label.h>
#include <Xm/CascadeB.h>
#include <Xm/Separator.h>
#include <Xm/PanedW.h>
#include <Xm/Text.h>
#include <Xm/FileSB.h>
#include <Xm/ToggleB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/MessageB.h>

#include <Xm/XmStrDefs.h>

#ifdef __cplusplus
extern "C" {
#endif
unsigned char LookUpArgIndex(char *);
unsigned char LookUpClassIndex(char *);
#ifdef __cplusplus
}
#endif
/* Define the type 'CreateFunction' to be a pointer to a function
// that returns a 'Widget'
*/
typedef Widget (*CreateFunction)(Widget, String, ArgList, Cardinal);

typedef struct _CreateFunctionsType{
  char *Name;
  CreateFunction function;
} CreateFunctionsType;

extern CreateFunctionsType CreateFunctions[];
extern int ClassSize;

typedef struct _ArgNamesType {
  char *Name;
  String theString;
} ArgNamesType;

typedef struct _PredefinedType {
  char *Name;
  XtPointer value;
} PredefinedType;

XtPointer LookUpFunction(String FunctionName);
XtPointer LookUpPredefines(String Name);

extern ArgNamesType ArgNames[];
extern PredefinedType Predefines[];
extern int ArgSize;
extern int PreSize;
#endif



