/**
 *
 * $Id: TextIn.c,v 1.2 1996/08/12 02:15:13 miers Exp $
 *
 * Copyright (C) 1995 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

 static char rcsid[] = "$Id: TextIn.c,v 1.2 1996/08/12 02:15:13 miers Exp $";

#include <LTconfig.h>
#include <XmI/XmI.h>
#include <XmI/DebugUtil.h>

#include <Xm/XmP.h>
#include <Xm/TextP.h>
#include <stdio.h>
#ifdef HAVE_STRING_H
#include <string.h>
#define ANSI_STRING
#else
#include <strings.h>
#endif
#include <stdlib.h>

/*
 * MLM: FIXME -- without these, misc/test1.c won't compile.  Perhaps these
 * should be installed on the subparts?
 */
char _XmTextIn_XmTextEventBindings1[] =
    ":m <Key>osfPrimaryPaste:   cut-primary() \n\
     :a <Key>osfPrimaryPaste:   cut-primary() \n\
     :<Key>osfPrimaryPaste:     copy-primary() \n\
     :m <Key>osfCut:            cut-primary() \n\
     :a <Key>osfCut:            cut-primary() \n\
     :<Key>osfCut:              cut-clipboard() \n\
     :<Key>osfPaste:            paste-clipboard() \n\
     :m <Key>osfCopy:           copy-primary() \n\
     :a <Key>osfCopy:           copy-primary() \n\
     :<Key>osfCopy:             copy-clipboard() \n\
     s c <Key>osfBeginLine:     beginning-of-file(extend) \n\
     :c <Key>osfBeginLine:      beginning-of-file() \n\
     s <Key>osfBeginLine:       beginning-of-line(extend) \n\
     :<Key>osfBeginLine:        beginning-of-line() \n\
     s c <Key>osfEndLine:       end-of-file(extend) \n\
     :c <Key>osfEndLine:        end-of-file() \n\
     s <Key>osfEndLine:         end-of-line(extend) \n\
     :<Key>osfEndLine:          end-of-line() \n\
     s <Key>osfPageLeft:        page-left(extend) \n\
     :<Key>osfPageLeft:         page-left() \n\
     s c <Key>osfPageUp:        page-left(extend) \n\
     :c <Key>osfPageUp:         page-left() \n\
     s <Key>osfPageUp:          previous-page(extend) \n\
     :<Key>osfPageUp:           previous-page() \n\
     s <Key>osfPageRight:       page-right(extend) \n\
     :<Key>osfPageRight:        page-right() \n\
     s c <Key>osfPageDown:      page-right(extend) \n\
     :c <Key>osfPageDown:       page-right() \n\
     s <Key>osfPageDown:        next-page(extend) \n\
     :<Key>osfPageDown:         next-page() \n\
     :<Key>osfClear:            clear-selection() \n\
     :<Key>osfBackSpace:        delete-previous-character() \n\
     s m <Key>osfDelete:        cut-primary() \n\
     s a <Key>osfDelete:        cut-primary() \n\
     s <Key>osfDelete:          cut-clipboard() \n\
     :c <Key>osfDelete:         delete-to-end-of-line() \n\
     :<Key>osfDelete:           delete-next-character()";


char _XmTextIn_XmTextEventBindings2[] =
    ":c m <Key>osfInsert:       copy-primary() \n\
     :c a <Key>osfInsert:       copy-primary() \n\
     s <Key>osfInsert:          paste-clipboard() \n\
     :c <Key>osfInsert:         copy-clipboard() \n\
     :s <Key>osfSelect:         key-select() \n\
     :<Key>osfSelect:           set-anchor() \n\
     :<Key>osfActivate:         activate() \n\
     :<Key>osfAddMode:          toggle-add-mode() \n\
     :<Key>osfHelp:             Help() \n\
     :<Key>osfCancel:           process-cancel() \n\
     s c <Key>osfLeft:          backward-word(extend) \n\
     :c <Key>osfLeft:           backward-word() \n\
     s <Key>osfLeft:            key-select(left) \n\
     :<Key>osfLeft:             backward-character() \n\
     s c <Key>osfRight:         forward-word(extend) \n\
     :c <Key>osfRight:          forward-word() \n\
     s <Key>osfRight:           key-select(right) \n\
     :<Key>osfRight:            forward-character() \n\
     s c <Key>osfUp:            backward-paragraph(extend) \n\
     :c <Key>osfUp:             backward-paragraph() \n\
     s <Key>osfUp:              process-shift-up() \n\
     :<Key>osfUp:               process-up() \n\
     s c <Key>osfDown:          forward-paragraph(extend) \n\
     :c <Key>osfDown:           forward-paragraph() \n\
     s <Key>osfDown:            process-shift-down() \n\
     :<Key>osfDown:             process-down() \n\
     c ~m ~a <Key>slash:        select-all() \n\
     c ~m ~a <Key>backslash:    deselect-all() \n\
     s ~m ~a <Key>Tab:          prev-tab-group() \n\
     c ~m ~a <Key>Tab:          next-tab-group() \n\
     ~m ~a <Key>Tab:            process-tab() \n\
     c ~s ~m ~a <Key>Return:    activate() \n\
     ~c ~s ~m ~a <Key>Return:   process-return() \n\
     c ~s ~m ~a <Key>space:     set-anchor() \n\
     c s ~m ~a <Key>space:      key-select() \n\
     s ~c ~m ~a <Key>space:     self-insert() \n\
     <Key>:                     self-insert()";


char _XmTextIn_XmTextEventBindings3[] =
    "<Unmap>:                    unmap() \n\
     <EnterWindow>:              enter() \n\
     <LeaveWindow>:              leave() \n\
     <FocusIn>:                  focusIn() \n\
     <FocusOut>:                 focusOut() \n\
     ~c s ~m ~a <Btn1Down>:      extend-start() \n\
     c ~s ~m ~a <Btn1Down>:      move-destination() \n\
     ~c ~s ~m ~a <Btn1Down>:     grab-focus() \n\
     ~c ~m ~a <Btn1Motion>:      extend-adjust() \n\
     ~c ~m ~a <Btn1Up>:          extend-end() \n\
     <Btn2Down>:                 process-bdrag() \n\
     m ~a <Btn2Motion>:          secondary-adjust() \n\
     ~m a <Btn2Motion>:          secondary-adjust() \n\
     ~s <Btn2Up>:                copy-to() \n\
     ~c <Btn2Up>:                move-to()";

/*
 * MLM: FIXME -- I don't know if this is a bug in the Solaris/IXI/Motif
 * header file (TransltnsP.h), or if there is a fourth TextIn binding.
 * Check this.
 */
#if 0
char _XmTextIn_XmTextEventBindings3[] =
    "<Unmap>:                        unmap() \n\
     <EnterWindow>:                  enter() \n\
     <LeaveWindow>:                  leave() \n\
     <FocusIn>:                      focusIn() \n\
     <FocusOut>:                     focusOut() \n\
     ~c s ~m ~a <Btn1Down>:          extend-start() \n\
     c ~s ~m ~a <Btn1Down>:          move-destination() \n\
     ~c ~s ~m ~a <Btn1Down>:         grab-focus() \n\
     ~c ~m ~a <Btn1Motion>:          extend-adjust() \n\
     ~c ~m ~a <Btn1Up>:              extend-end() \n\
     <Btn2Down>:                     process-bdrag() \n\
     m ~a <Btn2Motion>:              secondary-adjust() \n\
     ~m a <Btn2Motion>:              secondary-adjust() \n\
     ~s <Btn2Up>:                    copy-to() \n\
     ~c <Btn2Up>:                    move-to()";
#endif

static void
Invalidate(XmTextWidget w, XmTextPosition start, XmTextPosition end,
  long delta)
{
}

static void
GetValues(Widget aw, ArgList args, Cardinal num_args)
{
}

static void
SetValues(Widget old, Widget request, Widget new,
  ArgList args, Cardinal * num_args)
{
}

static void
destroy(Widget aw)
{
  XmTextWidget w = (XmTextWidget) aw;
  
  DBGW("destroy");

  (*Text_Source(w)->RemoveWidget)(Text_Source(w),w);
  XtFree((char *)Text_Input(w));
}

static void
GetSecResData(XmSecondaryResourceData *secres)
{
}

InputRec inputRec = {
    /* _InputDataRec             */ NULL,
    /* InputInvalidateProc       */ Invalidate,
    /* InputGetValuesProc        */ GetValues,
    /* InputSetValuesProc        */ SetValues,
    /* XtWidgetProc              */ destroy,
    /* InputGetSecResProc        */ GetSecResData
};

void
_XmTextInputCreate(Widget aw, ArgList args, Cardinal num_args)
{
  XmTextWidget w = (XmTextWidget) aw;
  XmTextInnerWidget iw = (XmTextInnerWidget) w->text.inner_widget;
  InputData i;

  DBGW("_XmTextInputCreate");
  
  Text_Input(w) = (Input) XtMalloc(sizeof(InputRec));
  memcpy(Text_Input(w), &inputRec, sizeof(InputRec));

  i = Text_Input(w)->data = &iw->inner.in;

  if (!Text_Source(w))
    Text_Source(w)=_XmStringSourceCreate(Text_Value(w),False);

  (*Text_Source(w)->AddWidget)(Text_Source(w),w);

  In_SelArray(i)=NULL;
  In_SelArrayIndex(i)=0;
  
  In_LastTime(i)=0;
}



/*
 * Quasi-Public functions -----------------------------------------------------
 */


Widget
_XmTextGetDropReciever(Widget w)
{
}

Boolean
_XmTextHasDestination(Widget w)
{
}

void
_XmTextInputGetSecResData(XmSecondaryResourceData *secResDataRtn)
{
}

XmTextPosition
_XmTextGetAnchor(XmTextWidget tw)
{
}

Boolean
_XmTextSetDestinationSelection(Widget w,
			       XmTextPosition position,
			       Boolean disown,
			       Time set_time)
{
}

Boolean
_XmTextSetSel2(XmTextWidget tw,
	       XmTextPosition left,
	       XmTextPosition right,
	       Time set_time)
{
}

Boolean
_XmTextGetSel2(XmTextWidget tw,
	       XmTextPosition *left,
	       XmTextPosition *right)
{
}

